/////////////////////////////////////////////////////////////////////////////////////////
//
// Change log file for ComponentOne Wijmo 5
//
/////////////////////////////////////////////////////////////////////////////////////////

=========================================================================================
Build Number 5.20181.436                  Build Date: 03/16/2018
=========================================================================================

* Bug fixes
	- [FlexSheet] Unlike previous build, ‘gotFocus’ event fire on page load. (TFS 313386)

=========================================================================================
Build Number 5.20181.434                  Build Date: 03/14/2018
=========================================================================================

* Bug fixes
	- [FlexSheet] Table cannot be removed by pressing 'Backspace/Delete' key after delete 
	  once in the sheet. (TFS 312127)

=========================================================================================
Build Number 5.20181.433                  Build Date: 03/13/2018
=========================================================================================

* Bug fixes
	- [PureJS][ReportViewer] ‘Match case’ and ‘Match whole word only’ options in
	  ‘Search’ pane are not working for ‘ActiveReports’. (TFS 312385)
	- [PureJS][PdfViewerIntro][ReportViewerIntro] 'ViewMode' cannot change back to
	  ‘Single’ when unchecking ‘Continuous View Mode’ checkbox. (TFS 312173)

=========================================================================================
Build Number 5.20181.432                  Build Date: 03/12/2018
=========================================================================================

* Bug fixes
	- [FlexSheet] Table cannot be removed by pressing 'Backspace/Delete' key after delete 
	  once in the sheet. (TFS 312127)
	- [FlexSheet] Hidden groups and rows are shown in FlexSheet when import an Excel file 
	  containing hidden groups and rows. (TFS 312122)

* Improvements
	- Wijmo is published to the global npm registry as the 'wijmo' package.
	   1) To install the release builds
			> npm install wijmo						// latest
			> npm install wijmo@5.20173.431			// specific version

	   2) To install RC builds
			> npm install wijmo@rc                  // latest
			> npm install wijmo@5.20181.432-rc      // specific version

	   3) To install nightly builds
			> npm install wijmo@nightly								// latest
			> npm install wijmo@5.20173.431-nightly.d20180312.t0720 // specific version (suffix denotes build date/time)
	  
	  The on-line npm packages offer Wijmo modules in the CommonJS format.
	  Alternative module formats are available in the NpmImages folder of 
	  Wijmo download zip as before.

	- Wijmo npm images now include css styles and culture files:
	  -- wijmo.css in the 'styles' subfolder. Usage example:
		 import 'wijmo/style/wijmo.css';
	  -- themes css in the 'themes' subfolder. Usage example:
		 import 'wijmo/themes/wijmo.theme.dark.css';
	  -- culture js files in the 'cultures' subfolder. Usage example:
		 import 'wijmo/cultures/wijmo.culture.ja';

=========================================================================================
Build Number 5.20173.431                  Build Date: 03/07/2018
=========================================================================================

* Bug fixes
	- [FlexSheet] [IE] CustomEditor gets lost first charecter in quick edit mode if edit 
	  mode is changed to full edit mode for frozen columns. (TFS 307919)

=========================================================================================
Build Number 5.20173.430                  Build Date: 03/06/2018
=========================================================================================

* Improvements
	- Improved ARIA support on FlexGrid, FlexGridFilter, and ComboBox components.

* Bug fixes
	- [Excel] The height of cells change in exported file. (TFS 301891)
	- [FlexSheet] Error is occurred when any row or column in table is dragged and dropped
	  by pressing 'Shift' key. (TFS 309197)
	- [PdfViewer][ReportViewer]‘Rotate Document’ and ‘Rotate Page’ rotation cannot be
	  applied for the pages in ‘Page Thumbnails’ view when opening ‘Page Thumbnails’
	  and clicking the buttons. (TFS 310742)
	- [FlexSheet] Cell contents in Table sheet are still remained after cut and paste 
	  operations. (TFS 311064)
	- [ReportViewer] Search result cannot show in search result panel at second time
	  when search by 'space' key after change the page orientation. (TFS 310845)
	- [Angular/AngularJS] GroupHeader template content may disappear on horizontal
	  scroll.

=========================================================================================
Build Number 5.20173.428                  Build Date: 02/25/2018
=========================================================================================

* Bug fixes
	- [FlexSheet] '[object Object]' shows on status bar which uses 'evaluate' method when 
	  selecting Date format cells. (TFS 309204)
	- [FlexSheet] Numeric values show with 2 decimal places and thousand separators when 
	  use 'setCellData' method. (TFS 309203)
	- [FlexSheet] Cells become distorting by undo action after inserting new row or column 
	  if 'applyCellsStyle' method is called. (TFS 310277)
	- [ExcelBook][FlexSheet] Some inconsistent descriptions are mentioned and error is 
	  occurred in certain scenario. (TFS 309191) 
	- [FlexSheet][Query] 'Convert To Table' feature is not supported in bound sheet and 
	  errors occurs when use 'addTable' methods. (TFS 291319)
	- [FlexSheet] Error is occurred when header row in bound sheet is set as 'Header Row'
	  of table. (TFS 306840)
	- [FlexSheet] Some cell content lost after 'showTotalRow' property is set as true and 
	  then false. (TFS 308489)
	- [FlexSheet] Loading base64 to FlexSheet for the same FlexSheet causes to change 
	  Column Width and row height. (TFS 310207)
	- Javascript error occurs after add the new sheet if the bound sheet is already added.
	  (TFS 308515)
	- Cannot set column header for FlexSheet. (TFS 309810)
	- [FlexSheet] addFunction method throws error when minParam=0 and no parameter is 
	  provided to function. (TFS 309227)

=========================================================================================
Build Number 5.20173.427                  Build Date: 02/20/2018
=========================================================================================

* Bug fixes
	- Internal bug fixes.

=========================================================================================
Build Number 5.20173.426                  Build Date: 02/19/2018
=========================================================================================

* Bug fixes
	- Internal bug fixes.

=========================================================================================
Build Number 5.20173.417                  Build Date: 02/22/2018
=========================================================================================

* Bug fixes
    - IMPORTANT: this build doesn't include changes introduced in the interim builds 410-412.
	- Fixed FlexGrid scroll on macOS issue.

=========================================================================================
Build Number 5.20173.416                  Build Date: 02/16/2018
=========================================================================================

* Bug fixes
    - IMPORTANT: this build doesn't include changes introduced in the interim builds 410-412.
	- Fixed FlexGrid scroll on macOS issue.

=========================================================================================
Build Number 5.20173.412        Build Date: 02/15/2018
=========================================================================================

* Improvements
	- [FlexSheet] Expose _filter as public property instead of private. (TFS 305043)
	- [FlexGrid] Added support for Column.textAlign = 'justify-all'. 
	  This new setting explicitly sets CSS properties textAlignLas and textJustify,
	  which is important for ideograph-based languages such as Chinese and Japanese.
	- Configs of all Angular and React npm module based samples are updated to support
	  symlinked modules installation.

* Bug fixes
	- [Excel] Can't set style.hAlign = Justify. (TFS 308945)
	- [FlexSheet] Observed Excel problem when export sheet containing a Table after perform 
	  excel-style drag drop. (TFS 290999)

=========================================================================================
Build Number 5.20173.411        Build Date: 02/12/2018
=========================================================================================

* Improvements
	- [olap.PivotPanel] Added support for hierarchical field structures in non-cube data sources.
	  For example:
        var theEngine = new wijmo.olap.PivotEngine({
            autoGenerateFields: false,
            fields: [
                { header: 'Dimensions', subFields: [
                    { binding: 'country', header: 'Country' },
                    { binding: 'product', header: 'Product' },
                ]},
                { header: 'Measures', subFields: [
                    { binding: 'sales', header: 'Sales' },
                    { binding: 'expenses', header: 'Expenses' },
                ]},
            ],
            itemsSource: getData(1000) // some array
        });

* Bug fixes
	- [PdfExport] Console error occurs when exporting ‘Drawing FlexPie (SVG)’ file
	  to PDF. (TFS 306992)
	- [FlexSheet] Unable to get focus in FlexSheet using KeyBoard navigation in IE and 
	  FireFox. (TFS 306843)
	- FlexReport Viewer parameter is missing the “<select value>” option. (TFS 307692)
	- [FlexSheet] Some hyperlink can not be pasted for Flex. (TFS 307044)
	- [FlexSheet] Unlike previous build, column/row cannot be inserted after delete all 
	  columns or rows. (TFS 308435)
	- [FlexSheet] Script error occurs when opening context-menu in empty FlexSheet.
	  (TFS 308434)
	- [FlexSheet] Bound sheet data disappear when insert/delete row in bound sheet, undo 
	  and change selected sheet. (TFS 308450)

=========================================================================================
Build Number 5.20173.410        Build Date: 02/08/2018
=========================================================================================

* Improvements
	- Added a wijmo.setLicenseKey method that enables single-build deployment, including npm.
	  If the licenseKey is not set, Wijmo runs in evaluation mode (with a  watermark). 
	  Setting the licenseKey (keys are provided to customers on our site) causes Wijmo to 
	  run in production mode (no watermark).
	- Added a FlexGrid.autoScroll property that determines whether the grid should automatically
	  scroll its contents when the user drags rows or columns near the edges of the control.

* Bug fixes
	- [FlexSheet][IE11][Firefox] Unlike previous build, error occurs when insert/delete 
	  row or column in bound/unbound sheet. (TFS 306745)
	- [FlexSheet] Unlike previous build, 'Min' and 'Max' formula cells which reference cells
	  are date cells show incorrect value when delete first cell from range. (TFS 306833)
	- [FlexSheet] Unlike previous build, script error occurs when initialized FlexSheet 
	  using 'initialize' method. (TFS 306901) 
	- [FlexSheet][Query] Observed inconsistent behaviors when date format cells are used 
	  as cell range in Max, Min and Average formulas. (TFS 300259)
	- [FlexSheet][Query] 'Convert To Table' feature is not supported in bound sheet and 
	  errors occurs when use 'addTable' methods. (TFS 291319)
	- [FlexSheet] Observed incorrect behaviors if 'showTotalRow' property is set as true.
	  (TFS 291528)
	- [FlexSheet] Filtering in bound sheet which is bound to CollectionView data is cleared 
	  unintentionally after change selected sheet. (TFS 307000)
	- [FlexSheet] Deleted data cannot be restored by undo if key navigation between cells 
	  is occurred. (TFS 306980)
	- [FlexSheet] Observed script errors and inconsistent behaviors when an excel file 
	  including table is imported and 'showTotalRow' is set as true. (TFS 306997)
	- [ReportViewer Sample]Error occurs when navigate to 'SSRS' report from
	  'FlexReport' report in some conditions. (TFS 305407)
	- [ExcelBook] Console error occurred when empty table is selected and check 'Total Row' 
	  checkbox from 'Table Style Options'. (TFS 306725)
	- [FlexSheet][Query] Request to clarify that nested table are able to create. (TFS 306809)
	- [FlexSheet] Chart do not show properly if table cell range is selected and then 
	  insert chart. (TFS 306969)
	- [FlexSheet][Query] Applied formats are inconsistent when initial page load and after 
	  entered edit mode. (TFS 306453)
	- [Wijmo5][FlexSheet]A UnboundSheet doesn't show border of Selection Range in a certain 
	  case.  (TFS 306968)
	- [FlexSheet] inserRows/deleteRows do not works if FlexSheet is sorted in bound sheet.
	  (TFS 306348)
	- [FlexSheet] Difference in FlexSheet's filter and sorting functionality. (TFS 306358)
	- [PureJS][ReportViewer] Console error occurs when printing ‘Active Reports’. (TFS 307283)
	- [PureJS][ReportViewer] Incorrect UI is observed in ‘Document Map’,
	  ‘Page Thumbnails’ and ‘Export’ panel of ‘Active Reports’. (TFS 307265)
	- [PureJS][ReportViewer][IE] JavaScript runtime error occurs when a report is
	  selected from ‘FlexReport’ dropdown. (TFS 306831)

=========================================================================================
Build Number 5.20173.409 (release)        Build Date: 02/06/2018
=========================================================================================

* Bug fixes
      IMPORTANT: this build doesn't include changes introduced in the interim build 406.
	- Fixed CSS dropdown button issue in FireFox.

=========================================================================================
Build Number 5.20173.408                  Build Date: 02/05/2018
=========================================================================================

* Bug fixes
      IMPORTANT: this build doesn't include changes introduced in the interim build 406.
	- Fixed CSS dropdown button issue.
	- Fixed FlexGrid scroll on macOS issue.

=========================================================================================
Build Number 5.20173.406        Build Date: 01/31/2018
=========================================================================================

* Improvements
    - [Olap] Added support for binding PivotEngine components directly to SSAS cubes.
      Previously, binding to SSAS cubes required setting a server and with ComponentOne 
      data engine services which exposed the cubes.
      Now, you can bind the PivotEngine *directly* to the SSAS cubes. For example:
         var ng = new wijmo.olap.PivotEngine({
             itemsSource: {
                 url: 'http://ssrs.componentone.com/OLAP/msmdpump.dll',
                 cube: 'Adventure Works'
             }
         });
    - [Excel] Added support for tables in the FlexSheet control and wijmo.xlsx module.
      The ExcelBook/FlexSheetIntro/FlexSheetExplorer samples have  been updated to 
      demonstrate the new feature.
    - [ReportViewer] Added support for the GrapeCity ActiveReports report generator.
      The PureJS ReportViewer sample has been updated to demonstrate the new feature.
    - [React] Added support for child components representing complex objects for some 
      control properties, for example FlexGridColumn for FlexGrid Column objects and
      FlexChartSeries for Chart Series objects.
      So from now on in addition to the static columns definition like this
        <Wj.FlexGrid 
            autoGenerateColumns={ false }
            columns={[
                { header: 'Country', binding: 'country', width: '*' },
                { header: 'Date', binding: 'date' },
                { header: 'Revenue', binding: 'amount', format: 'n0' },
                { header: 'Active', binding: 'active' }
            ]}
            itemsSource={ this.state.data } />
      you can use the following dynamic definition
        <Wj.FlexGrid 
            itemsSource={this.state.data} >
            <Wj.FlexGridColumn header={this.state.countryHeader} binding="country" width="*" />
            <Wj.FlexGridColumn header="Date" binding="date" />
            <Wj.FlexGridColumn header="Revenue" binding="amount" format="n0" />
            <Wj.FlexGridColumn header="Active" binding="active" />
        </Wj.FlexGrid>
      This improvement makes it possible to dynamically update array property items, for 
      example a set of grid columns, with the 'render' code like this:
                    <Wj.FlexGrid
                        itemsSource={this.state.data}>
                            {this.state.columnsDefinitions.map((colDef) => {
                                return <Wj.FlexGridColumn key={colDef.binding} binding={colDef.binding} />
                            }
                        )}
                    </Wj.FlexGrid>

    - [FlexGrid] Added a Column.multiLine (and Row.multiLine) feature that supports
      multi-line text in cells. Setting multiLine to true causes the cell to honor
      embedded line-break characters (\n) when rendering the cell content.
      Users may enter line breaks by pressing alt+Enter, as in Excel.
    - [Globalize] Added support for escaped characters in date formats, e.g.
      wijmo.Globalize.format(date, '\\h h \\m m'); // h 3 m 55

* Bug fixes
    - [FlexSheet] Script error occurs when adding a new sheet if there is a bound sheet 
      with groups. (TFS 305274)
    - [CSS] Fixed layout bug for buttons inside input controls. In the last build we 
      introduced a bad fix which caused the input controls to be too tall. This fix
      solves the original issue and newly introduced issue.
    - [PDF] Column footer row on the bottom of page is clipped. (TFS 306056)
    - [ReportViewer] Error occurs when the report has a not nullable DateTime type
      parameter and it's value is null. (TFS 306344)
    - [FlexSheet] Content in header row of the table is disappeared by undo operation.
      (TFS 291039)
    - [FlexSheet] Data format changes when convert to Table after selecting a cell range 
      containing date or currency data. (TFS 291307)
    - [FlexSheet] Observed incorrect behaviors if 'showTotalRow' property is set as true.
      (TFS 291528)
    - [FlexSheet][Query] 'Convert To Table' feature is not supported in bound sheet and 
      errors occurs when use 'addTable' methods. (TFS 291319)
    - [FlexSheet] Script error occurs and the FlexSheet is not responding on converting 
      a cell range to table when a table exists in the sheet. (TFS 291890)
    - [FlexSheet] Observed Excel problem when export sheet containing a Table after perform
      excel-style drag drop. (TFS 290999)
    - [FlexSheet][Query] Observed inconsistent behaviors when date format cells are used 
      as cell range in Max, Min and Average formulas. (TFS 300259)
    - [FlexGrid]  FlexGrid groupHeader unable to export apostrophe(') as it is. (TFS 299907)
    - [FlexSheet] FlexSheet copy/paste action loose Cell Formatting and causes to invalid 
      Cell Reference for ($). (TFS 301007)
    - [FlexSheet] Scrolling occur if data is pasted from Excel Sheet. (TFS 297615)
    - [FlexSheet] All cell ranges of formula do not update when drag and drop the column 
      containing formula. (TFS 291592)
    - [FlexSheet] Observed incorrect behaviors when clicking top-left cell if 'allowAddNew'
      and 'newRowAtTop' properties are set as true. (TFS 298073)
    - [FlexSheet] deletingRow and deletedRow event do not get triggered on deleting row 
      in spite of allowDelete to true (TFS 296947)

=========================================================================================
Build Number 5.20173.405 (release)        Build Date: 01/18/2018
=========================================================================================

* Bug fixes
    - Rolled back wijmo glpyhs that broke in chrome for macOS. The broken glyphs were: 
      calendar, clock, minus, plus. 
      IMPORTANT: this build doesn't include changes introduced in the interim build 404.

=========================================================================================
Build Number 5.20173.404                  Build Date: 01/12/2018
=========================================================================================

* Improvements
    - Added a wijmo.nav.TabPanel control that provides tab navigation.
      This new control can be used to replace bootstrap tabs, which require 
      bootstrap.js and jQuery.
    - [React] Added child components support.

* Bug fixes
    - [FlexSheet] Cell value deleted using Delete key did not trigger rowEditEnded 
      event when changing Row selection. (TFS 304432)

=========================================================================================
Build Number 5.20173.403 (release)        Build Date: 01/09/2018
=========================================================================================

* Improvements
    - Added 'refreshing' and 'refreshed' events to the Control class.
      These events occur before and after the control is refreshed, and
      enable some customization scenarios.

* Bug fixes
    - [wijmo.pdf] drawImage method did not support base64-encoded images with MIME
      type "image/jpeg".

=========================================================================================
Build Number 5.20173.402                  Build Date: 01/08/2018
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.401                  Build Date: 01/05/2018
=========================================================================================

* Bug fixes
    - [FlexSheet] Clipboard actions do not work properly when paste by selecting a cell 
      range. (TFS 303844)

=========================================================================================
Build Number 5.20173.400                  Build Date: 01/04/2018
=========================================================================================

* Improvements
    - [Olap] Added a PivotPanel.showFieldIcons property that determines whether the panel
      should show icons next to the fields indicating whether the field is a dimension
      (defines categories) or a measure (contains numeric values that can be aggregated).
    - [Olap] Added a PivotPanel.restrictDragging property that determines whether the panel
      should restrict drag operations to prevent users from dragging dimension fields 
      into the value field list and measure fields into the row or column fields.

* Bug fixes
    - [FlexSheet] Cut and paste actions do not work properly after filtering in certain 
      scenario. (TFS 303360)
    - [FlexSheet] Cut action do not work properly for Number cells if no format setting 
      for number column in bound sheet. (TFS 303417)
    - [FlexSheet] Unlike previous build, console error occurs and newly added sheet distorts 
      when add an unbound sheet at first index using 'addUnboundSheet' method. (TFS 303345)
    - [React samples] Samples which are based on external modules included dated version
      of the wijmo.min.css file.

=========================================================================================
Build Number 5.20173.399                  Build Date: 12/28/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Cut action does not work properly after filtering is applied. (TFS 302751)
    - [FlexSheet] Function 'rand()' does not work properly when pressing 'Enter' key.
      (TFS 302478)
    - [FlexSheet] Filter do not work properly for "=rand()" formula like Excel. (TFS 229468)

=========================================================================================
Build Number 5.20173.398                  Build Date: 12/27/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Function 'rand()' does not work properly when pressing 'Enter' key.
      (TFS 302478)
    - [FlexSheet] Error message shows for formula with named cell range when column before 
      formula is deleted. (TFS 302486)

=========================================================================================
Build Number 5.20173.397                  Build Date: 12/26/2017
=========================================================================================

* Improvements
    - [Popup] Added an isDraggable property that makes dialogs draggable. Draggable
      dialogs must contain an element with the .wj-dialog-header class. Users will be
      able to drag the dialog by clicking and dragging the header element.
    - [Cultures] wijmo.culture.XX.js files can now be loaded using 
      import 'wijmo.culture.XX'; 
      or
      require('wijmo.culture.XX');
      statements in Webpack-based bundlers without applying a script-loader to them.

=========================================================================================
Build Number 5.20173.396                  Build Date: 12/25/2017
=========================================================================================

* Improvements
    - [Excel] useJSZip function is added to the wijmo.xlsx module, which allows to
      provide wijmo.xlsx with a reference to the 'jszip' module in the npm modules
      based applications. This can be done now with a code like this:
        import * as JSZip from 'jszip';
        import * as wjcXlsx from 'wijmo/wijmo.xlsx';
        wjcXlsx.useJSZip(JSZip);
      The Angular ExcelImportExport sample, "FlexGrid Import Export (JSZip 3)" example
      is updated accordingly to demonstrate the method usage.

* Bug fixes
    - [Excel] The height of cells change in exported file. (TFS 301891)


=========================================================================================
Build Number 5.20173.395                  Build Date: 12/21/2017
=========================================================================================

* Bug fixes
    - [FlexPivot][Excel] 'Transposed View' is not exported with correct font and color 
      when generate view with Column fields only. (TFS 301513)
    - [React][ReportViewerIntro] Icons on the toolbar are misplaced and overlapped.
      (TFS 300681)
    - InputDateTime control is used now instead of InputDate if parameter type is
      DateTime. (TFS 299889)
    - Date and time editors now display blank value instead of current date if
      parameter value is not set. (TFS 299889)
    - [FlexSheet] FlexSheet copy/paste action loose Cell Formatting and causes to invalid 
      Cell Reference for ($). (TFS 301007)
    - [Angular/AngularJS] Resolved some problems with cell editing initialization triggered
      by the keyboard input, when Wijmo input controls are used as cell editors.

=========================================================================================
Build Number 5.20173.394                  Build Date: 12/19/2017
=========================================================================================

* Improvements
    - [Olap] Allow generating views with value fields only (grand totals) or 
      row/column fields only (unique values).
    - [FlexGrid] Added a 'refresh' parameter to the CellEditEnding event parameters.
      This allows event handlers to suppress the full refresh that happens by default
      when cell editing ends.

* Bug fixes
    - Globalize.formatString did not work correctly with scientific notation values
      and truncate = true.
    - [FlexSheet] Can't enter value when validation is failed at first. (TFS 301195)
    - [FlexSheet]  Issues in Sorting with Filter dialog. (TFS 299490)
    - [Angular/AngularJS] A control in FlexGrid cell edit template may get a wrong 
      initial value after a another cell was previously edited in the nested FlexGrid.
      

=========================================================================================
Build Number 5.20173.392                  Build Date: 12/17/2017
=========================================================================================

* Bug fixes
    - [Excel] Error occurred when the specific MS Excel file is imported. (TFS 300979)

=========================================================================================
Build Number 5.20173.391                  Build Date: 12/13/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.390                  Build Date: 12/11/2017
=========================================================================================

* Improvements
    - Made some changes in wijmo.pdf code that make it possible to use Wijmo PdfDocument
      in NodeJS (with a specific Domino based setup). The public API adds the 
      PdfDocumentEndedEventArgs.chunks property, which returns an array of Uint8Array
      objects that can be saved to a file or a stream using NodeJS file API.

* Bug fixes
    - [FlexGrid] FlexGrid groupHeader unable to export apostrophe(') as it is. (TFS 299907)
    - [FlexSheet] Selection loses after undo and redo actions of deleting rows or columns
      (TFS 299873)
    - [FlexSheet] HTML tags show on formula bar and exported excel file if part of cell 
      content consist of rich text format. (TFS 299058)
    - Removed change made to OData value filter in build 352 (it caused issues).

=========================================================================================
Build Number 5.20173.388                  Build Date: 12/07/2017
=========================================================================================

* Bug fixes
    - [Wijmo5 WebApi][Viewer]"500 internal error" displays after searching second
      time before the result of first time come out. (TFS 257527)
    - [FlexSheet] Unlike previous build, cell value cannot be deleted properly when cells 
      are moving with key navigation. (TFS 229525)
    - Custom editor is not able to get focus in FlexSheet. (TFS 296961)
    - [FlexSheet]  Issues in Sorting with Filter dialog. (TFS 299490)

=========================================================================================
Build Number 5.20173.387                  Build Date: 12/05/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Error occurred in Clipboard operations if 'allowAddNew' property is 
      set as 'True'. (TFS 289487)
    - [FlexSheet] Unlike previous build, keyboard navigation is not working correctly 
      when editing a row. (TFS 299005)
    - [FlexSheet] Scrolling occur if data is pasted from Excel Sheet. (TFS 297615)
    - [Angular] Doesn't trigger events on a disposed component.
    - [PdfViewer][ReportViewer][IE] All text is selected when ‘Zoom by Selection’ is
      dragged on the viewer. (TFS 299270)
    - [FlexSheet] Observed duplicate formula after double actions of undo and redo on 
      deleting columns. (TFS 299318)
    - [Excel] Error occurred when the excel file including cell borders and invalid 
      hyperlink is imported. (TFS 299404)
    - [Angular] All Angular samples are updated to use Angular 5.
    - [Samples] All npm modules based samples now use Wijmo modules in CommonJS format,
      instead of AMD as it was before.

=========================================================================================
Build Number 5.20173.384                  Build Date: 11/30/2017
=========================================================================================

* Improvements
    - Added several new members to the TreeView and TreeNode classes:
        TreeNode.addChildNode(index, dataItem) adds a child node to a TreeNode
        TreeView.addChildNode(index, dataItem) adds a child node to a TreeView
        TreeNode.remove() removes a node from the TreeView
        TreeNode.refresh() refreshes a node with updated data content
        TreeNode.itemsSource gets a reference to the array that contains the node data

=========================================================================================
Build Number 5.20173.383                 Build Date: 11/29/2017
=========================================================================================

* Improvements
    - Added an InputNumber.repeatButtons property that determines whether the control's 
      spinner buttons should act as repeat buttons (fire continuously while pressed).
    - Improved PivotEngine sorting of value fields (measures) to sort groups by aggregate.
      (this can be disabled by setting the new PivotEngine.sortableGroups property to false).
    - Improved PivotGrid collapse/expand to keep the original state of child nodes.
    - PivotGrid now honors the preserveOutlineState property (inherited from FlexGrid).
    - Improved FlexGrid layout performance.
    - Improved export to xlsx performance for FlexGrid containing Angular cell templates.
    - [Angular/AngularJS] textarea elements used as cell editors now correctly consume characters
      that were typed by a user to initiate cell editing.
    - [AngularJS] For FlexGrid with ime-enabled="true" and a cell editor represented by a 
      cell edit template, cell editing can now be correctly initiated by IME input.

* Bug fixes
    - [FlexSheet] NewRow template gets hidden on applying Filtering in FlexSheet. (TFS 292680)
    - [FlexSheet] Selected Cell style remain applied after making selection to Null.
      (TFS 295680)
    - [FlexSheet] Last edited cell get focused once Input Box is focused and start editing.
      (TFS 295674)
    - [FlexSheet] All rows or columns cannot be selected by clicking top-left cell in a 
      certain scenario. (TFS 297897)
    - [FlexSheet] Error occurred in Clipboard operations if 'allowAddNew' property is 
      set as 'True'. (TFS 289487)
    - FlexSheet initialization issue. (TFS 252562)
    - [FlexPivot] Observed Excel problem on opening exported xlsx when setting 'Format' 
      property to 'Thounsand (n2,)', 'Millions (n2,,)' or 'Billions (n2,,,)'. (TFS 297799)
    - [ExcelBook] Error occurred when chart is inserted in empty sheet. (TFS 297967)
    - [FlexSheet] Pressing ‘Control + Space’ key to select a column is not working properly
      in bound sheet. (TFS 298275)
    - [ReportViewer] Incorrect behavior is observed when choosing items from
      Cascading Parameters dropdown. (TFS 298047)
    - [FlexSheet] deletingRow and deletedRow event do not get triggered on deleting row 
      in spite of allowDelete to true. (TFS 296947)
    - [FlexSheet] e.data does not get updated copy-paste operation performed within Control
      (TFS 291053)
    - ReportViewer: Unable to set back parameter value to Null. (TFS 296927)
    - [FlexSheet] Empty/null records cannot be filtered by 'Equal/Does not equal' condition
      with empty value. (TFS 289899)
    - [Excel] Thousand separators are not exported to Excel format when setting 'format' 
      property to Percentage (p0 or p2). (TFS 288869)
    - [ReportViewer] "Zoom by selection" and "Magnifier" doesn't support mobile
      device. (TFS 289417)
    - [FlexSheet] Cell range in formula do no update after cut and paste cells. (TFS 284210)
    - [FlexSheet][iOS] 'Insert/Delete' context-menu appears when resizing a column or row
      in unbound sheet. (TFS 292032)
    - [Excel][iOS] Empty columns are exported incorrectly when export to Excel format on 
      iPad. (TFS 292060)
    - [PdfViewer][ReportViewer][Firefox] Incorrect mouse action is observed when
      using ‘Zoom by Selection/Magnifier’ on image area. (TFS 280215)
    - [FlexSheet] deleteRows/InsertRows method do not work for bounded sheet. (TFS 285698)

=========================================================================================
Build Number 5.20173.381                 Build Date: 11/17/2017
=========================================================================================

* Bug fixes
    - Some bug fixes.

=========================================================================================
Build Number 5.20173.380 (release)       Build Date: 11/11/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.379                 Build Date: 11/09/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.378                 Build Date: 11/08/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.376                 Build Date: 11/07/2017
=========================================================================================

* Bug fixes
    - [PdfViewer] Observed different behaviors in different browsers when printing
      the Pdf. (277894)
    - ReportViewer print layout on IE is broken. (277516)

=========================================================================================
Build Number 5.20173.375                 Build Date: 11/06/2017
=========================================================================================

* Improvements
    - Made some improvements in InputNumber's editing experience.

=========================================================================================
Build Number 5.20173.373                 Build Date: 11/05/2017
=========================================================================================

* Bug fixes
    - [PDFViewer] PDFViewer viewMode cannot be set to continuous at initialization.
      (TFS 294064)
    - [Angular] For FlexGrid with cell templates, column resizing may cause an exception 
      under some specific conditions.

=========================================================================================
Build Number 5.20173.372                 Build Date: 11/02/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.371                 Build Date: 11/01/2017
=========================================================================================

* Improvements
    - [Angular] It's confirmed that Wijmo for Angular interop is compatible with
      just released Angular 5. Earlier Angular versions are still supported as well.

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.370                 Build Date: 10/30/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.369                 Build Date: 10/29/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.368                 Build Date: 10/26/2017
=========================================================================================

* Improvements
    - Improved accessibility (ARIA attributes and keyboard support) for the 
      ListBox, ComboBox, Menu, InputNumber, Gauge, and Calendar controls.

* Bug fixes
    - [Angular] Exception when starting editing of a cell with an edit template whose
      DOM tree doesn't contain any 'input' element.

=========================================================================================
Build Number 5.20173.367                 Build Date: 10/24/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.366                 Build Date: 10/23/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20173.365                 Build Date: 10/22/2017
=========================================================================================

* Improvements
    - Added a quickAutoSize property to the wijmo.grid.FlexGrid and wijmo.grid.Column classes.
      This new property can improve auto-sizing performance by a factor of 10 to 100, 
      depending on the scenario/browser.

* Bug fixes
    - [PdfViewer][ReportViewer] ‘Compressed metafiles’ cannot be exported properly
      when setting the page range. (285173)
    - [ReportViewer][PdfViewer] Buttons on left toolbar are still highlighted
      although left panel is already closed. (281325)
    - [ReportViewer][PdfViewer] Some themes do not apply properly in toolbar icons,
      full-screen toolbar and Export tab. (280537)

=========================================================================================
Build Number 5.20173.364                 Build Date: 10/19/2017
=========================================================================================

* Bug fixes
    - [Pdf] Currency columns (format = ‘c’ or ‘c2’) cannot be exported correctly to
      PDF format. (289900)
    - [PdfExport] Console error occurs when non-color text is entered in 'Color'
      column and export customize cells with color format. (288836)
    - [FlexSheet][Query] Header row of table cannot be deleted by context menu. (TFS 290335)
    - [FlexSheet] Table format is removed in exported excel file if table includes merged 
      cells. (TFS 291184)
    - ReportViewer Height cannot be set to 100%. (291181)

* Breaking Changes
    - [xlsx] Support for xlsx tables in wijmo.xlsx and wijmo.grid.sheet modules is temporary 
      removed. Its release is postponed to a later time.

=========================================================================================
Build Number 5.20173.363                 Build Date: 10/16/2017
=========================================================================================

* Bug fixes
    - [FlexSheet][Query] Header row of table cannot be deleted by context menu. (TFS 290335)
    - [FlexSheet] Table cannot be converted to cell range by undo operation and total row 
      in other table is disappeared. (TFS 290368)
    - [FlexSheet] Observed Excel problem when export sheet containing a Table after 
      perform excel-style drag drop. (TFS 290999)
    - [FlexSheet] Table format is removed in exported excel file if table includes merged
      cells. (TFS 291184) 
    - [FlexSheet][Query] 'addColumn' method of 'Table' class is not working as expected.
      (TFS 291108)

=========================================================================================
Build Number 5.20173.362                 Build Date: 10/11/2017
=========================================================================================

* Improvements
    - Improved popup positioning on mobile devices with pinch-zooming (including Android and IOS).

* Bug fixes
    - [FlexSheetIntro] Error occurs in a certain scenario when insert column in 
      'Formulas' sample. (TFS 289494)
    - [FlexSheet] Error occurs in Clipboard operations if 'allowAddNew' property is 
      set as 'True'. (TFS 289487)
    - [ExcelBook][Query] Observed some inconsistent behaviors. (TFS 290381)
    - [ExcelImportExport] Error occurs when the excel file is exported. (TFS 290664)
    - [FlexSheet][Query] Request to clarify how to remove the Table. (TFS 290415)
    - [FlexSheet] Table cannot be converted to cell range by undo operation and total row 
      in other table is disappeared. (TFS 290368)

=========================================================================================
Build Number 5.20173.361                 Build Date: 10/09/2017
=========================================================================================

* Improvements
    - [FlexGrid] Added support for row/column resizing on touch devices.
    - [xlsx] Support for xlsx tables is added to wijmo.xlsx and wijmo.grid.sheet
      modules. The Excelbook, FlexSheetExplorer and FlexSheetIntro samples are updated
      to demonstrate the new feature.

* Bug fixes
    - [ReportViewer] Console errors occur when selecting multiple pages with
      ‘Zoom by Selection’. (TFS 286775)

=========================================================================================
Build Number 5.20173.360                 Build Date: 10/02/2017
=========================================================================================

* Improvements
    - This build includes all changes of build 358.
    - [wijmo.grid.pdf] Added support of cell text wrapping in FlexGrid.

=========================================================================================
Build Number 5.20172.359                 Build Date: 09/28/2017
=========================================================================================

* Bug fixes
    - Internal regression fix for build 357.
      IMPORTANT: this build doesn't include changes introduced in the interim build 358.

=========================================================================================
Build Number 5.20172.358                 Build Date: 09/24/2017
=========================================================================================

* Improvements
    - [Angular/AngularJS] Editing of cells with cell edit templates if forcibly started
      in full edit mode now by default. In full edit mode pressing cursor keys don't finish 
      cell editing, which is important if controls that process cursor keys (like ComboBox)
      are used as cell editors. This is formally a compatibility breaking change, 
      see the "Breaking Changes" section for details.
      You can change this functionality by setting the forceFullEdit property of the
      WjFlexGridCellTemplate directive to false.

* Bug fixes
    - [FlexSheet][FlexSheetExplorer] Error occurs in certain scenario of page navigation.
      (TFS 287662)
    - [Angular/Docs] Added missed WjFlexGridCellTemplate property descriptions.

* Breaking Changes
    - [Angular] Two-way bound properties now update the model asynchronously (like the 
      ng-model directive).
      Before this build, changing the control property updated the model immediately.

=========================================================================================
Build Number 5.20172.357                 Build Date: 09/21/2017
=========================================================================================

* Improvements
    - Made Popup ignore Escape key while IME mode is active.
    - Added UndoStack sample that shows how to provide customizable/form-level undo/redo services

* Bug fixes
    - [FlexSheet] Editing data-mapped cell and checkbox cell cannot be canceled by pressing
      'Esc' key in bound sheet. (TFS 286372)
    - Add the error process for PivotEngine.
    - [FlexSheet][Chrome] Observed inconsistent behavior in copy and paste cells after 
      sorting Boolean column. (TFS 286744)
    - [InputDate][Excel] Numeric value is exported incorrectly when export InputDate value 
      to Excel format. (TFS 286761)
    - [FlexSheet] Only checked state (true) is pasted when any data type is cut or copied 
      (TFS 286756)

=========================================================================================
Build Number 5.20172.355                 Build Date: 09/18/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20172.354                 Build Date: 09/17/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Drop-down opens and closes immediately when open datamap drop-downs 
      continuously. (TFS 285981)
    - [FlexPivot][Excel] Observed Excel problem when exporting PivotGrid containing 'NaN' 
      or 'Infinity %'. (TFS 286019)

=========================================================================================
Build Number 5.20172.353                 Build Date: 09/14/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] First character lost when entering a cell on the new row for the first 
      time. (TFS 285280)
    - [FlexSheet] Cell content are still remained if cut operation is done in certain 
      scenario. (TFS 285300)
    - [FlexSheet] Column header is changed when field name of itemsSource includes slash.
      (TFS 285277)
    - [FlexGrid][Excel] String column alignment is incorrectly exported to Excel when first 
      column is string type in grouping grid. (TFS 285263)
    - [AngularJS] Under some specific conditions, an input control in CellEdit template may 
      be filled with previously typed characters when cell editing begins

=========================================================================================
Build Number 5.20172.352                 Build Date: 09/12/2017
=========================================================================================

* Improvements
    - Made OData value filter smarter. Now it serializes the lesser of items checked
      or unchecked, which results in shorter URLs and prevents request errors in some
      common scenarios (like un-checking one or two items out of a huge number).
    - Added some configuration properties to the wijmo.olap.PivotEngine class:
        serverTimeOut: the timeout value for retrieving results from the server.
        serverPollInterval: the poll interval for getting progress reports from the server.
        serverMaxDetail: the maximum number of detail records to retrieve from the server.

* Bug fixes
    - [Excel] Large value formatted as string is displayed as exponent value. (TFS 284770)
    - [FlexSheet] 'Square root' formula do not calculate properly when imported Excel file 
      containing 'sqrt' formulas. (TFS 284753)

=========================================================================================
Build Number 5.20172.351                 Build Date: 09/10/2017
=========================================================================================

* Improvements
    - [Angular] Sometimes Wijmo components' normal functionality could lead to the
      ExpressionChangedAfterItHasBeenCheckedError exception when Angular runs in 
      development mode. Now all two-way bindings to Wijmo properties are updated 
      asynchronously in the target-to-source direction, which prevents from triggering
      this exception. This behavior change could potentially break some parts of your
      applications, so it can be changed to synchronous binding updates, globally or for
      a specific component. See the "Breaking Changes" section for details.
    - [Angular] Before now, the e.cancel property of the FlexGrid.cellEditEnding event
      was always set to true if a cell editor is implemented as a CellEdit template.
      From now on, this property has a consistent value that reflects actual user's
      action.

* Bug fixes
    - [Excel] Fixed export string issue.
    - [FlexSheet] Script error occurs when copy and paste after cut the cell contents in 
      editor. (TFS 284779)

* Breaking Changes
    - [Angular] Two-way bound properties now update the model asynchronously (like the 
      ngModel directive). Before this build, changing the control property updated the 
      model immediately. Asynchronous updates save your applications from the 
      ExpressionChangedAfterItHasBeenCheckedError exception that may be caused by Wijmo 
      components under some specific conditions when Angular runs in development mode. 
      This behavior can be changed back to synchronous updates:
      -- Globally for all Wijmo components, by setting the static WjOptions.asyncBindings
         property to false. For example:
            import { WjOptions } from 'wijmo/wijmo.angular2.directiveBase';
            WjOptions.asyncBindings = false;
      -- For a specific component, by assigning component's asyncBindings property with 
         a false value.
      See the WjOptions.asyncBindings property description for details. The WjOptions
      class is contained in the wijmo.angular2.directiveBase module.

=========================================================================================
Build Number 5.20172.350                 Build Date: 09/06/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Error occurs when drag and drop row or column. (TFS 283757)
    - [FlexSheet] Error occurs when filter editor is opened after removing a column.
      (TFS 284031)

=========================================================================================
Build Number 5.20172.349                 Build Date: 09/04/2017
=========================================================================================

* Bug fixes
    - [MultiRowExplorer] Observed incorrect behaviors when scrolling MultiRow and footer 
      grid in 'Purchase Slip' sample. (TFS 281209)
    - [FlexSheet] Add or subtract to date formulas cannot be exported as date format to 
      Excel file. (TFS 283730)

=========================================================================================
Build Number 5.20172.348                 Build Date: 09/03/2017
=========================================================================================

* Improvements
    - [PdfExport sample] Added new sample, "Highlight invalid cells" (Angular 1/2).

* Bug fixes
    - [FlexSheet] New row is still at the top of control after content is inserted and 
      'Enter' is pressed. (TFS 280478)
    - [Excel] Some borders of merged cells are not exported to Excel. (TFS 281243)
    - [FlexSheet] Cell range in formula do not update after drag and drop the column.
      (TFS 281114)
    - [FlexSheet] All data are exported in filtered sheet when open other sheet and export
      the FlexSheet. (TFS 281199)
    - [MultiRowExplorer] Observed incorrect behaviors when scrolling MultiRow and footer 
      grid in 'Purchase Slip' sample. (TFS 281209)
    - [InputTime] Call to the Control.invalidateAll() method may cause triggering the
      valueChanged event twice, first of them with an invalid control value.

=========================================================================================
Build Number 5.20172.347                 Build Date: 08/30/2017
=========================================================================================

* Improvements
    - Added a FlexGrid.toggleDropDownList method to show the list of options when 
      editing cells with data maps.
    - [FlexGridPdfConverter] Added a IFlexGridStyle.errorCellStyle property.

* Bug fixes
    - [FlexGrid][Pdf] Validation errors cannot be exported to PDF format. (TFS 292236)
    - [FlexSheet] New row is still at the top of control after content is inserted and 
      'Enter' is pressed. (TFS 280478)
    - [FlexSheet] Incorrect selection is observed when copy a cell and paste on a cell 
      range after sorting or filtering. (TFS 280469)

=========================================================================================
Build Number 5.20172.346                 Build Date: 08/24/2017
=========================================================================================

* Improvements
    - [FlexGridPdfConverter] Improved handling of boolean columns in
      customCellContent mode.
    - [Angular] New Angular samples were added (ported from AngularJS and PureJS).

* Bug fixes
    - Wijmo FlexSheet export to excel and column order issue. (TFS 227920)
    - [FlexSheet] Error occurs when a new sheet is added after importing the excel file
      with named cell range. (TFS 280162)
    - Default border style exported to xlsx incorrectly. 

=========================================================================================
Build Number 5.20172.345                 Build Date: 08/23/2017
=========================================================================================

* Improvements
    - [Angular] Wijmo components don't cause change detection anymore for frequently 
      triggered events like mousemove, to which components are subscribed internally.
    - Added a KeyAction.CycleOut setting to support tabbing through cells and then
      on to the next control on the form (see FlexGrid.keyAction property).
    - Made FlexGrid.virtualizationThreshold property public, deprecated old internal
      '_virtualizationThreshold' version.

* Bug fixes
    - [FlexSheet] Error occurs when Excel file created from Japanese environment is 
      imported. (TFS 279283)
    - [FlexSheet][ExcelBook] Script error occurs when clicking on formula bar after loaded 
      an empty Excel file. (TFS 279247)
    - [FlexSheet] Undo and redo actions do not work properly after sorting the column two 
      times. (TFS 279602) 
    - [FlexSheet] Thousand separators appears in numbers when enter into edit mode and exit.
      (TFS 279721)

=========================================================================================
Build Number 5.20172.344                 Build Date: 08/21/2017
=========================================================================================

* Improvements
    - [FlexSheet][Enhancement] Request to support undo and redo for filtering action.
      (TFS 278949)
    - [Angular/AngularJS/Knockout] Improved FlexGrid with cell templates performance 
      for operations like column resizing, row addition, cell editing ending, and many more.

* Bug fixes
    - [FlexSheet] Numeric values show on axis of chart when a chart is inserted on the 
      merged date cell range. (TFS 278913)
    - [FlexSheet] Sorting do not work and data disappear after editing cell in bound sheet.
      (TFS 279256)

=========================================================================================
Build Number 5.20172.343                 Build Date: 08/17/2017
=========================================================================================

* Improvements
    - Added new culture files: wijmo.culture.es-MX.js (Spanish/Mexico) and
      wijmo.culture.es-419.js (Spanish/Latin America).
    - Added a Popup.removeOnHide property to control whether the Popup should be
      removed from the DOM or just hidden when the popup closes.

* Bug fixes
    - [FlexSheet] Count function do not work properly in the imported file. (TFS 278358)
    - [FlexSheet][IE11] Unlike previous build, script errors occur when navigate from the 
      page containing bound FlexSheet to another page. (TFS 278723)
    - [ReportViewer][ComboBox] ComboBox is not working properly after chose an item
      from a ComboBox in ‘Parameters’ tab. (TFS 277901)
    - [FlexSheet] Unlike previous build, observed script error and empty sheet when sorting 
      a column in bound sheet. (TFS 278735)
    - [FlexSheet] All data disappear in bound sheet after copy and paste the cell. (TFS 278732)
    - [Knockout] The InputNumber.value property binding is not initialized if binding to the
      'format' property is used on the same control.
    - [Knockout] wjTooltip binding raises an exception on initialization.
    - [PdfViewer][ReportViewer] Incorrect mouse action is observed using ‘Zoom by
      Selection’, ‘Continuous Page View’ and rotating in a certain scenario. (TFS 277972)
    - [FlexSheet] Script error occurs on clicking top-left cell when there is no sheet in 
      the FlexSheet. (TFS 278937)
    - [FlexSheet] Data rows containing formulas disappear when undo after deleting 2 columns 
      in filtered sheet. (TFS 278934) 

=========================================================================================
Build Number 5.20172.342                 Build Date: 08/14/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] 'Invalid Expression' error shows when insert/delete a column at the left
      of scientific formula. (TFS 277039)
    - [FlexSheet] Scroll position does not maintain and context-menu shows at incorrect 
      position when scroll and insert/delete through context-menu. (TFS 277040)
    - [FlexSheet] Rows containing formulas disappear on deleting a column when filtering 
      a column containing formulas. (TFS 277041)
    - [FlexSheet] Cut and paste operations do not work properly after filtering. (TFS 277082)
    - [FlexSheet] Selection shows incorrectly when select columns/rows and sort a column.
      (TFS 277791)
    - [FlexSheet] Cleared columns and rows appear again when add column/row by context menu
      after clear rows and columns. (TFS 277439)
    - [FlexSheet] Most functions can not be copied and pasted properly. (TFS 277542)
    - [FlexSheet] Function 'substitute' does not work properly if fourth parameter for 
      instance is used. (TFS 277069)
    - [FlexSheet] JavaScript error occurs when cut operation is done while mouse button
      is not released. (TFS 277077)
    - [FlexSheet] Some date formats with function cannot be exported properly. (TFS 277496)
    - [FlexSheet] Error message show for formula with named cell range in certain scenario.
      (TFS 277945)

=========================================================================================
Build Number 5.20172.341                 Build Date: 08/08/2017
=========================================================================================

* Improvements
    - [Angular] New Angular samples were added (ported from AngularJS and PureJS).

* Bug fixes
    - [Angular] Items in the WjFlexChartAnnotationLayer.items array are incorrectly
      ordered when defined using WjFlexChartAnnotation components.
    - [React] Fixed some issues with bindings to object and array properties.

=========================================================================================
Build Number 5.20172.340                 Build Date: 08/06/2017
=========================================================================================

* Bug fixes
    - [PdfViewer][ReportViewer][Chrome] Incorrect mouse action is observed when using
      ‘Zoom by Selection’. (TFS 275380)
    - [PdfViewer][ReportViewer] Incorrect mouse action is observed when using
      ‘Magnifier’. (TFS 275697)
    - [PdfViewer][ReportViewer] Page navigation is not working correctly after
      rotating in ‘Continuous Page View’ mode. (TFS 275702)
    - [FlexSheet][IE11] Error message is shown for 'value' formula with percentage format.
      (TFS 275050)
    - [FlexSheet] Filter by value (nothing) is not working correctly when entering empty/null 
      values in the cells. (TFS 275641)

=========================================================================================
Build Number 5.20172.339                 Build Date: 08/02/2017
=========================================================================================

* Improvements
    - [FinancialChart] Added new financial chart type 'PointAndFigure'. The demo page
      included in Angular2 FinancialChartExplorer sample.

* Bug fixes
    - [FlexSheet][IE11] Error message is shown for 'value' formula with percentage format.
      (TFS 275050)
    - [PdfViewer][ReportViewer] Printing is not working properly. (TFS 275182).
    - [FlexSheet] Error occurs when 'Ctrl+Z' key is pressed in certain scenarios.
      (TFS 275025)
    - [FlexSheet] 'countifs' formula do not work and error message is shown when import 
      an Excel file containing 'countifs' formula. (TFS 275029)
    - [FlexSheet][IE] JavaScript error occurs when a cell or cell range is selected 
      and pasted. (TFS 275620)
    - [FlexSheet] Filter by value (nothing) is not working correctly when entering empty/null 
      values in the cells. (TFS 275641)
    - [FlexSheet] Error messages show when 'true' or 'false' is included in 'If' formula
      (TFS 275683)
    - [Angular2][PdfExport] File cannot export properly in some cases in
      'Export FlexGrid to a file' sample. (TFS 275253)
    - [FlexPivot] Console error occur when exported to XLSX file if format is changed in 
      Pivot grid using Field setting. (TFS 275313)
    - [FlexSheet] Filtering is not maintained when insert or remove row/column in the sheet.
      (TFS 275682)
    - [FlexSheet] Error occurs when import and export the file which include equal 
      sign (=) as text. (TFS 275704)
    - [FlexSheet] Filter dialog open and close immediately when a cell is in edit mode.
      (TFS 275766)
    - [FlexSheet] Sorting do not work properly after filtering. (TFS 275763)
    - [FlexSheet][Enhancement] Request to support Hyperlink in control. (TFS 275778)
    - [FlexSheet] Reference cells in formula changed incorrectly after any row above formula
      is deleted. (TFS 275117)

=========================================================================================
Build Number 5.20172.338                 Build Date: 07/26/2017
=========================================================================================
* Improvements
    - [ReportViewer] Hide the Parameters tab if all parameters are hidden.
    - Added Intellisense support for Wijmo Angular components for VSCode HTML editor. 
      It's implemented in the wijmo5-ng2-1.0.0.vsix file located in the Intellisense
      folder of Wijmo download zip, which should be installed as VSCode extension.
      For more details about installing the file refer to the accompanying readme.txt
      file located in the same folder.

* Bug fixes
    - [FlexSheet] Merged cell values are rendered in the chart when insert a chart after 
      merged cell ranges. (TFS 260249)
    - [FlexSheet] Some cells become empty when Undo operation is done after Cut and Paste 
      operations. (TFS 275284) 

=========================================================================================
Build Number 5.20172.337                 Build Date: 07/25/2017
=========================================================================================

* Improvements
    - [React] Added components for all Wijmo controls. Added AllComponents sample that 
      demonstrates all available components.

* Bug fixes
    - [FlexSheet] Key navigation do not work in context menu. (TFS 236214)
    - [FlexSheet] Does not show error message when extra text is entered next to 
      formula. (TFS 236205)
    - [FlexSheet] Focus lost from control after filter editor is opened. (TFS 269923)
    - [FlexSheet] Some inconsistent behaviors are observed when pressing 'Home,End and Arrow Keys'  
      in edit mode of any cells. (TFS 275018)
    - [FlexSheet] Error message is shown for all functions which do not need parameters.
      (TFS 275012)
    - [FlexSheet] Scroll-bars do not scroll automatically to selected cell when press 
      Page Up, Page Down, Home and End keys. (TFS 275175)
    - [FlexSheet] 'Text' formula do not work properly after copy and paste it. (TFS 236281)
    - [Angular] Eliminated the AOT compiler warning: "Can't resolve all parameters for 
      WjValueAccessor in ..../node_modules/wijmo/wijmo.angular2.directiveBase.d.ts: (?). 
      This will become an error in Angular v5.x"


=========================================================================================
Build Number 5.20172.336                 Build Date: 07/20/2017
=========================================================================================

* Improvements
    - Reduced code size of the Angular, React and Vue2 interops. 
    - [React] Wijmo for React interop can be used now in a project that contains React 
      declaration files (.d.ts). This may be a compatibility breaking change for your 
      React projects that use Wijmo, see the "Breaking Changes" section for details.
    - Added a MultiSelect.showSelectAllCheckbox property to display a "Select All"
      checkbox above the items, so users can select/de-select all items with a single
      click (in addition to the ctrl+A keyboard shortcut that performs the same
      function).
    - Added a MultiSelect.selectAllLabel property to customize the label shown next
      to the "Select All" checkbox displayed when the showSelectAllCheckbox
      property is set to true.
    - Added wijmo.chart.radar module. Destined to support FlexChartBase.saveImageToFile
      and saveImageToDataUrl methods in IE11. 

* Bug fixes
    - [ReportViewer] Console error occurs when changing page ‘Orientation’ after
      opening ‘Page Thumbnail’ and changing the report type. (TFS 265781)
    - Added a new PivotField.sortComparer property to allow customization of the sort order
      in dimension fields. This is similar to the CollectionView's sortComparer property, except
      it applies to pivot dimensions (grid headers) as opposed to measures (summary data).
    - Vertical alignment settings not getting imported from the Excel file. (TFS 261328)
    - Merged cell values are rendered in the chart when insert a chart after merged cell 
      ranges. (TFS 260249)
    - 'Max/Min' formula cells work incorrectly when delete last row from formula range. 
      (TFS 260263)
    - Cell range in formula do not update when reference sheet is used and insert new row
      or column. (TFS 260044) 
    - countif function do not work properly when the value what is looking for is empty.
      (TFS 262180)
    - saveAsync doesn't work as an optional parameter. (TFS 265463)
    - [FlexSheet] Sorting operations using filter dialog cannot be performed if itemsSource 
      is set using a service call. (TFS 261846)
    - [FlexSheet] Value filter list is empty in filter dropdown when the sheet is bound 
      to tree hierarchical data. (TFS 260260)
    - It does not show error message although extra text are entered next to formula.
      (TFS 236205)
    - [FlexSheet] 'Text' formula do not work properly after copy and paste it. (TFS 236281)
    - [FlexSheet] Key navigation do not work in context menu. (TFS 236214)
    - Deleting the read-only cell set by 'beginningEdit' event works incorrectly.
    - Column headers do not render correctly when loading 'columnLayout' in the FlexSheet.
      (TFS 267138)
    - Value formula do not work properly for some content. (TFS 236283)
    - 'Ceiling' formula do not work and error show when second parameter is entered. (TFS 239333)
    - 'Text' formula does not work properly for some format. (TFS 236286)
    - Error occurs when 'Ctrl+X' key combination is pressed on empty sheet. (TFS 268409)
    - 'Text' formula convert dates to incorrect text when use nested functions and formats.
      (TFS 236798)
    - [FlexSheet] Formula does not get reference of newly added row if sheet is bound 
      to array. (TFS 268764)
    - [FlexSheet] Some cells are wrapped in exported file. (TFS 268974)
    - [FlexSheet] Countif formula does not work for date format 'Month/Day/Year'. (TFS 236201)
    - [FlexSheet] Multiple issues are observed when setting 'allowMerging' property is set
      to All in a sheet. (TFS 203996)
    - [FlexSheet] Error occurs in unbound sheet when sorting and deleting columns in 
      a certain scenario. (TFS 269917)
    - [FlexSheet] Focus lost from control after filter editor is opened. (TFS 269923)
    - [FlexSheet] Column containing formulas cannot be sorted correctly when inserted a 
      formula in a cell. (152149)
    - [Angular2][ExcelImportExport] Console error occurs when any file is imported.
      (TFS 270094)
    - [ExcelImportExport] Tree structure cannot render in FlexGrid When import an exact 
      Excel file with tree data using JSZip 3. (TFS 270144)
    - Printing rotated document. (TFS 268915)
    - Excel throws 'Unreadable Content' error, if excel content infinity as cell value.
      (TFS 270429)
    - Is formatItem for custom cell content export works only for cell? (TFS 270152)
    - [FlexPivot][Excel] Row headers align to center vertically in exported Excel files when
      setting 'centerHeadersVertically' property to False. (TFS 270501)
    - [FlexPivot][Excel][Pdf] Column headers of PivotGrid are not corrected aligned in 
      exported Excel/Pdf document. (TFS 269938)
    - The selected style of the multiple selections will lost after scrolling.
    - [React] Unable to bind to objects (non-arrays), for example to bind GroupPanel.grid
      to a FlexGrid reference.
    - [Wijmo5 MVC][FlexViewer][Query] Request to dim all buttons on toolbar and
      sidebar while the report is loading. (TFS 257532)
    - [FlexSheet] If named range have formula name, cell evaluating named range shows error 
      in the cell. (TFS 273992)
    - [FlexSheet] Conditional filtering without setting filter value does not work properly 
      in unbound sheet. (TFS 204380)
    - [FlexSheet] text formula convert "d" format to number format during import/export 
      functionality. (TFS 274000)
    - [FlexSheet] Selection does not get updated with shift + arrow key. (TFS 273469)

* Breaking Changes
    - In previous versions of the FlexGrid, users could click the top-left header
      cell to select the whole grid content. In new versions, clicking any cell
      in the top-left panel selects the whole grid content.
    - [React] Wijmo for React interop now depends on React declaration files (.d.ts),
      which should be installed in a project that uses Wijmo for React interop. 
      The declaration files can be installed using the following npm command:
      > npm install @types/react @types/react-dom
      More details can be found here:
      https://www.typescriptlang.org/docs/handbook/react-&-webpack.html

=========================================================================================
Build Number 5.20172.334                 Build Date: 07/12/2017
=========================================================================================

* Bug fixes
    - [ExcelBook] Correct chart types in 'Insert Chart' listbox cannot be selected by mouse 
      click. (TFS 273027)
    - References to Wijmo culture files in .js files in TypeScript samples are incorrect,
      so culture change functionality doesn't work in cases where a sample was not compiled
      before running it.

=========================================================================================
Build Number 5.20172.333                 Build Date: 07/11/2017
=========================================================================================

* Improvements
    - StockChart samples reworked to use Quandle financial data service instead of the 
      abolished Yahoo Finance.

* Bug fixes
    - [FlexSheet] Error occurs in quick editing of number cell. (TFS 272779)
    - [FlexSheet] Formula in formula drop-down cannot be selected properly by key navigation.
      (TFS 272748)

=========================================================================================
Build Number 5.20172.332                 Build Date: 07/10/2017
=========================================================================================

* Improvements
    - Added a Column.maxLength property to limit the length of the built-in editor's
      input element.
    - [Angular] For FlexGrid with [imeEnabled]="true" and a cell editor represented by a 
      cell edit template, cell editing can now be correctly initiated by IME input.

* Bug fixes
    - [ExcelBook] Key navigation does not work in 'Insert Chart' dropdown. (TFS 272428)

=========================================================================================
Build Number 5.20172.331                 Build Date: 07/09/2017
=========================================================================================

* Bug fixes
    - Internal regressions fixes.

=========================================================================================
Build Number 5.20172.330                 Build Date: 07/06/2017
=========================================================================================

* Bug fixes
    - Internal regressions fixes.

=========================================================================================
Build Number 5.20172.329                 Build Date: 07/05/2017
=========================================================================================

* Bug fixes
    - [FlexGrid] PdfDocument drawText method does not render text after rendering
      two FlexGrids. (TFS 271441)
    - Changed FlexGridFilter's ConditionFilter to interpret treat null values as
      empty strings (as the ValueFilter does).
    - [MultiRow][MultiRowExplorer] Reflesh 'Purchase Slip' sample will throw error in FireFox.
      (TFS 271118)

=========================================================================================
Build Number 5.20172.328                 Build Date: 07/03/2017
=========================================================================================

* Bug fixes
    - [MultiRow][MultiRowExplorer][Pdf] Unlike previous build, script errors occur
      and Pdf file cannot be exported in ‘Purchase Slip’ sample. (TFS 271118)

=========================================================================================
Build Number 5.20172.327                 Build Date: 07/02/2017
=========================================================================================

* Bug fixes
    - JS error displays after clicking "Landspace" with thumbnail expand in
      "ReportViewer" sample. (TFS 268768)

* Improvements
    - The AngularJS Benchmark sample has been updated to the latest versions of vendor
      libraries.

=========================================================================================
Build Number 5.20172.326                 Build Date: 06/29/2017
=========================================================================================

* Bug fixes
    - [FlexPivot][Pdf] PivotGrid cannot render correctly in the exported Pdf when
      collapse row fields. (TFS 269971)
    - [MultiRowExplorer] MultiRow is not localized to Japanese Culture once setting from 
      'Culture' menu. (TFS 269937)
    - [FlexPivot][Pdf] Row headers align to center vertically in exported Excel and
      Pdf files when setting ‘centerHeadersVertically’ property to False. (TFS 270502)
    - [ReportViewer][PdfViewer] ‘Previous Page’ button is not dim when current page
      is first page in ‘Full Screen’ mode. (TFS 268948)

=========================================================================================
Build Number 5.20172.325                 Build Date: 06/29/2017
=========================================================================================

* Bug fixes
    - [FlexPivot][Pdf] Column headers of PivotGrid are not corrected aligned in
      exported Pdf document. (TFS 269938)

=========================================================================================
Build Number 5.20172.324                 Build Date: 06/27/2017
=========================================================================================

* Bug fixes
    - Internal regressions fixes.

=========================================================================================
Build Number 5.20172.323                 Build Date: 06/25/2017
=========================================================================================

* Improvements
    - Added a TreeView.loadTree method to rebuild the tree after making changes to 
      the itemsSource array.

* Bug fixes
    - [MultiRowExplorer] MultiRow is not localized to Japanese Culture once setting from 
      'Culture' menu. (TFS 269937)

=========================================================================================
Build Number 5.20172.323                 Build Date: 06/25/2017
=========================================================================================

* Improvements
    - [FlexGridPdfConverter] added support for PivotGrid.

* Bug fixes
    - [Angular] Fixed multiple issues with cell editing initiated by keypress, when
      a cell edit template defines the editor.

=========================================================================================
Build Number 5.20172.322                 Build Date: 06/21/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Selected cell range cannot be remained properly when undo action is done 
      after cut action. (TFS 268765)
    - [ReportViewer][PdfViewer][Android][iOS] Multiple issues are observed when
      ‘Tools’ and ‘Layout Options’ buttons are clicked. (TFS 268469)
    - [FlexSheet] Console error occurs when number is entered in first row if 
      newRowAtTop is set as true. (TFS 268818)
    - [Olap] The detail row show no items if the view contains a Date type field 
      in the OlapServerIntro sample. (TFS 240384)
    - [Angular][Angular2][ReportViewer][Android] No ‘Full Screen’ toolbar in
      ‘ReportViewer’ sample when changed to ‘FullScreen’ mode. (TFS 268410)

=========================================================================================
Build Number 5.20172.321                 Build Date: 06/19/2017
=========================================================================================

* Bug fixes
    - Internal regression fixes.

=========================================================================================
Build Number 5.20172.320                 Build Date: 06/18/2017
=========================================================================================

* Bug fixes
    - [Wijmo5 Mvc][FlexViewer][MobileView]It's better to set some description words
      in one line. (TFS 257531)
    - [ReportViewer] Console error occurs when changing the report after setting
      ‘Continuous Page View’ and changing page. (267927)
    - [React] Binding to the itemsSource property is never updated after it has been
      initialized for the first time.
      This fix may potentially cause a regression, see the Breaking Changes topic
      for details.
    - [React] Some control bindings may not update target property values in case where
      there is a binding to an array property defined for the same control.

* Breaking Changes
    - [React] itemsSource property of Wijmo components is updated now each time when 
      React updates component bindings. Because of this, if binding expression returns
      a new array or CollectionView each time it's called, even if it contains the same data 
      (e.g. function getData { return [1, 2, 3]; }), you may get weird effects in some
      controls, and even get a "Stack overflow" exception, because controls detects a different
      data source by comparing references to the current and the new data source instances,
      and refreshes control if references are different.
      You should make sure that binding expression returns the same instance of an array or a
      CollectionView, until a new instance is really required by the application logic.


=========================================================================================
Build Number 5.20172.319                 Build Date: 06/15/2017
=========================================================================================

* Bug fixes
    - [PdfViewer][ReportViewer] Incorrect ‘Magnifier’ behavior and console error is
      observed in a certain scenario. (TFS 267173)
    - Deleting the read-only cell set by 'beginningEdit' event works incorrectly.
    - Vertical alignment settings not getting imported from the Excel file. (TFS 261328)

=========================================================================================
Build Number 5.20172.318                 Build Date: 06/14/2017
=========================================================================================

* Bug fixes
    - [ReportViewer] The export option for FlexReport and SSRS is the same. (TFS 265396)
    - [PdfViewer][ReportViewer] Page number is inconsistent after changing from
      ‘Fit Whole Page’ to ‘Fit Page Width’ when toggle on ‘Continuous Page View’.
      (TFS 261618)

=========================================================================================
Build Number 5.20172.317                 Build Date: 06/13/2017
=========================================================================================

* Improvements
    - Reduced code size of the Angular, React and Vue2 interops. 
    - Added a new PivotField.sortComparer property to allow customization of the sort order
      in dimension fields. This is similar to the CollectionView's sortComparer property,
      except it applies to pivot dimensions (grid headers) as opposed to measures
      (summary data).
    - Added several new properties to make the Calendar control more customizable:
      formatYearMonth, formatDayHeaders, formatDays, formatYear, and formatMonths.
      All these properties represent format strings used to format different parts
      of the Calendar in month and year view.

* Bug fixes
    - [ReportViewer] Console error occurs when changing page ‘Orientation’ after
      opening ‘Page Thumbnail’ and changing the report type. (TFS 265781)
    - Vertical alignment settings not getting imported from the Excel file. (TFS 261328)
    - Merged cell values are rendered in the chart when insert a chart after merged cell 
      ranges. (TFS 260249)
    - 'Max/Min' formula cells work incorrectly when delete last row from formula range. 
      (TFS 260263)
    - Cell range in formula do not update when reference sheet is used and insert new row
      or column. (TFS 260044) 
    - countif function do not work properly when the value what is looking for is empty.
      (TFS 262180)
    - saveAsync doesn't work as an optional parameter. (TFS 265463)
    - [FlexSheet] Sorting operations using filter dialog cannot be performed if itemsSource 
      is set using a service call. (TFS 261846)
    - [FlexSheet] Value filter list is empty in filter dropdown when the sheet is bound 
      to tree hierarchical data. (TFS 260260)
    - It does not show error message although extra text are entered next to formula.
      (TFS 236205)
    - [FlexSheet] 'Text' formula do not work properly after copy and paste it. (TFS 236281)
    - [FlexSheet] Key navigation do not work in context menu. (TFS 236214)

* Breaking Changes
    - In previous versions of the FlexGrid, users had to click the *first* cell in
      the top-left panel to select the whole grid. In new versions, clicking *any* 
      cell in the top-left panel will select the whole grid.

=========================================================================================
Build Number 5.20171.315                 Build Date: 06/12/2017
=========================================================================================

* Bug fixes
    - Internal regressions fixes.

=========================================================================================
Build Number 5.20171.314                 Build Date: 06/11/2017
=========================================================================================

* Bug fixes
    - [ReportViewer]Javascript error occur when navigate to another report if
      continuous page is set and navigate to other page. (TFS 265286)

=========================================================================================
Build Number 5.20171.312                 Build Date: 06/08/2017
=========================================================================================

* Improvements
    - Added time zone offset date format parts ('z', 'zz', 'zzz') to Globalize.formatDate.

* Bug fixes
    - [wijmo.olap] Fix the wrong display for non-numeric types aggregating
      in server-side olap.
    - [Wijmo5 MVC][FlexViewer][ReportViewer] Javascript error is observed after
      changed the page orientation if page zoom size is changed. (TFS 257524)
    - [wijmo.viewer] If thumbnails view panel is displayed then the
      "Unable to get property 'style' of undefined or null reference" exception is
      thrown in IE11 after rotating the page or document.
    - [PdfViewer][ReportViewer]‘Rotate Document’ and ‘Rotate Page’ rotation cannot
      be applied for the pages in ‘Page Thumbnails’ view panel at the initial state.
      (TFS 257886)
    - [Wijmo5 MVC][FlexViewer] Javascript error is observed when user enter some
      special character(& or #) in search box. (TFS 257526)

=========================================================================================
Build Number 5.20171.310                 Build Date: 06/06/2017
=========================================================================================

* Bug fixes
    - [wijmo.viewer] If the document source has been changed after using the magnifier
      tool, then the tool will display the previous document's page when used until
      the current page is changed or tool is re-activated.
    - Missed support for the FlexGrid.deletedRow event is added to the 
      Angular/AngularJS/Knockout interops.
    - Links to the documentation are corrected in the PdfViewerIntro samples.

=========================================================================================
Build Number 5.20171.309                 Build Date: 06/05/2017
=========================================================================================

* Bug fixes
    -  Subfolders of the dist\interop\angular2 folder now include TypeScript definition 
       files (.d.ts).

=========================================================================================
Build Number 5.20171.307                 Build Date: 06/04/2017
=========================================================================================

* Bug fixes
    - [MultiRowExplorer] 'TypeError: Cannot set property 'align' of undefined' occurs and 
      footer grid cannot show in Chrome/Firefox when refreshing page after navigated to 
      'Purchase Slip' page. (TFS 260881)
    - [wijmo.viewer] The magnifier tool can display the area of another page in
      continuous view mode if more than one page is displayed at a time in the view.
    - [wijmo.viewer] In continuous view mode the magnifier tool's displayed area is
      offset relative to the one that is located under the cursor.
    - Added a new PivotField.sortComparer property to allow customization of the sort order
      in dimension fields. This is similar to the CollectionView's sortComparer property, except
      it applies to pivot dimensions (grid headers) as opposed to measures (summary data).

=========================================================================================
Build Number 5.20171.305                 Build Date: 06/01/2017
=========================================================================================

* Bug fixes
    - [PdfViewer][ReportViewer] Script error occurs when the view panel is scrolled
      down/up after clicking ‘Magnifier’ button. (TFS 259422)
    - Can't reference a local named range of another sheet. (TFS 260970)
    - The format for the integer value is incorrect after exporting the FlexGrid to Excel.
      (TFS 260970)


=========================================================================================
Build Number 5.20171.304                 Build Date: 05/31/2017
=========================================================================================

* Bug fixes
    - Vue2ExternalModules sample's package.json is pinned to Vue version 2.2.6,
      in order to get rid of the 
      "style" is a reserved attributed and cannot be used as component prop....."
      error in browser console. It looks like caused by the following regression
      that should be fixed in the upcoming Vue release:
      https://github.com/nolimits4web/Framework7-Vue/pull/156
    - [FlexSheet] Error occurs in certain scenario of sorting. (TFS 261273)
    - [MultiRowExplorer] Unlike previous build, console errors occur when opening sample 
      pages. (TFS 260881)
    - [PdfViewer][ReportViewer] Mouse action is not working correctly after clicking
      'Rubberban Zoom' on the toolbar. (TFS 259419)
    - [ReportViewer][PdfViewer] Some strings are not localized when using Japanese and
      other cultures. (259428)
    - [FlexSheet] Unlike previous build, loading data takes very long time and browser is 
      not responding when data size is more than 500. (TFS 261309)

=========================================================================================
Build Number 5.20171.302                 Build Date: 05/28/2017
=========================================================================================

* Bug fixes
    - Paste operation do not work properly by clicking row and column headers. (TFS 260861)
    - Undo action do not work by pressing 'Ctr+Z' key combination at once. (TFS 260959)
    - [FlexSheet] Error occurs when other sheet is opened while drop-down is opening 
      in a sheet. (TFS 260916)
    - [FlexSheet] Error occurs when click the inserted chart. (TFS 260901)

=========================================================================================
Build Number 5.20171.301                 Build Date: 05/26/2017
=========================================================================================

* Improvements
    - Improved accessibility by adding ARIA 1.1 built-in support to 
      the following controls:
        - FlexGrid: https://www.w3.org/TR/wai-aria-1.1/#grid
        - TreeView: https://www.w3.org/TR/wai-aria-1.1/#tree
        - Gauge:    https://www.w3.org/TR/wai-aria-1.1/#range
        - ListBox:  https://www.w3.org/TR/wai-aria-1.1/#listbox
        - ComboBox: https://www.w3.org/TR/wai-aria-1.1/#combobox
        - Menu:     https://www.w3.org/TR/wai-aria-1.1/#menu
    - Added two new properties to improve FlexGrid keyboard accessibility:
        keyActionTab and keyActionEnter
      These properties allow you to customize the behavior of 
      special keys so the grid becomes more accessible or more
      compatible with Excel.
    - Added a new property to improve FlexGrid screen-reader accessibility:
        rowHeaderPath
      If provided, this property specifies the name of a binding to use as
      a provider of 'row header' accessibility values. If not provided, most
      readers will use the content of the first visible column as the row header.

    - Added a new FlexGrid.itemValidator property to improve validation support,
      especially for unbound grids (bound grids can be validated using the 
      CollectionView.getError property which provides the same functionality).
    - [Wijmo5 Mvc][FlexViewer]Internet error displays after running different report
      quickly in "FlexViewerExplorer" sample. (TFS 257523)
    - FlexGrid exports the default border and style of merged cell to xlsx incorrectly.
    - [ReportViewer][PdfViewer] ReportViewer and PdfViewer are partially localized
      when setting Cultures. (TFS 258374)
    - Added support for named ranges in wijmo.xlsx and wijmo.grid.sheet modules.
      The following members were added:
      -- IDefinedName interface and DefinedName class in the wijmo.xlsx module
      -- IWorkbook.definedNames: IDefinedName[]
      -- FlexSheet.definedNames: ObservableCollection (of IDefinedName objects)

* Breaking Changes
    - The default behavior of the Tab key when the FlexGrid has the focus has changed.
      By default, the Tab key cycled through the grid cells (Excel style).
      The new default behavior is to let the browser cycle through the elements on the 
      page (to improve accessibility).
      You can revert to the old behavior by setting the new keyActionTab property to
      wijmo.grid.KeyAction.Cycle.

=========================================================================================
Build Number 5.20171.300                 Build Date: 05/21/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Checkbox does not get disabled throw itemFormatter. (TFS 259117)
    - XLSX loading with shared formula error. (TFS 259118)
    - [FlexGrid] Sheet specified by name does not get imported. (TFS 259121)
    - [PDF]FlexGrid column header not getting exported when setting AllowAddNew to
      false. (TFS 258969)

=========================================================================================
Build Number 5.20171.299                 Build Date: 05/18/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Editing mode is on when select a merged cell range after selecting the 
      whole sheet. (TFS 258046)
    - [FlexSheet] Cell become blank on pressing 'Ctrl + V' key twice after cut a cell using 
      'Ctrl+X' key. (TFS 257797)
    - Fixed importing 'double' style border issue for xlsx importing. (TFS 214674)
    - [FlexSheet] Duplicate formula found when redo and undo after new column is inserted 
      in front of formula cell. (258979)

=========================================================================================
Build Number 5.20171.298                 Build Date: 05/17/2017
=========================================================================================

* Bug fixes
    - [FlexSheet] Deleting all contents takes very long time and browser is not responding 
      when the sheet contains over 300 rows. (TFS 258353)
    - Observed thicker border style and no frozen lines when import xlsx file which is 
      exported from FlexSheet. (TFS 258375)
    - [PdfViewer][ReportViewer] Console errors occur when running all the samples and
      clicking ‘Select Mouse Mode?’ check box in some samples. (TFS 257818)
    - [Angular2][PdfExport][AxisScrollbar][TreeMapIntro] Screenshot and readme files
      are missing in the samples. (TFS 257869)

=========================================================================================
Build Number 5.20171.297                 Build Date: 05/16/2017
=========================================================================================

* Bug fixes
    - [FlexSheet][ExcelBook] Script error occurs in certain scenario. (TFS 258043)
    - [Excel][FlexPivot] Script error occurs on exporting to Xlsx format when the PivotGrid 
      is empty. (TFS 258033)
    - Formula is updated incorrectly after sorting. (TFS 257783)

=========================================================================================
Build Number 5.20171.296                 Build Date: 05/15/2017
=========================================================================================

* Bug fixes
    - [PdfExport][IE11] Errors occur when exporting PDF using ‘customCellContent’
      and ‘formatItem’ properties of IFlexGridDrawSettings. (TFS 250357)
    - [Angular][FlexSheetExplorer][FlexSheetIntro][IE11] JavaScript error occurs when 
      the sample is run. (TFS 257773)
    - [PureJS][MultiRowIntro] Observed incorrect group header format for group headers of 
      'State' column. (TFS 256769)
    - [FlexSheet] on passing FlexGrid instance in bound sheet, formula gets off by one row.
      (TFS 257901)
    - Default border of Sheet gets lost on export. (TFS 257902)

=========================================================================================
Build Number 5.20171.294                 Build Date: 05/11/2017
=========================================================================================

* Improvements
    - Added new properties to the PivotChart control:
        - showTitle: whether the chart should include an automatically generated title.
        - showLegend: whether the chart should include a legend.
    - Added new properties to the PivotGrid control:
        - showRowFieldHeaders: whether the grid's top-left panel should display row field headers
        - showColumnFieldHeaders: whether the grid's top-left panel should display row field headers
    - Added a new Gauge.tickSpacing property to allow customization of the
      spacing between tick marks.
    - Added a FlexSheet.addFunction method that replaces the obsolete addCustomFunction  
      method. 
      Custom functions added using this method support references to cells in other sheets
      and support function parameter values in a more consistent manner: as two-dimensional
      arrays of resolved values.
    - Added Angular2 versions of the OlapIntro, OlapModal and PdfExport samples.
    - New TreeMap chart control is added to the wijmo.chart.hierarchical module.
      The TreeMapIntro sample (PureJS/AngularJS/Angular) is added to showcase 
      the control's features. 

    - Optimized startEditing method to update only the editor cell (no full refreshes)

* Bug fixes
    - When tree/hierarchical data is bound to a sheet, third-level items lost after adding
      a new sheet. (TFS 251919)
    - Double shortcut actions need to undo after cut by 'Ctrl+X' key. (TFS 249632)

* Breaking Changes
    - The FlexSheet.addCustomFunction method is marked as obsolete. Please use the
      FlexSheet.addFunction method instead.

=========================================================================================
Build Number 5.20171.293                 Build Date: 04/26/2017
=========================================================================================

* Improvements
    - None

=========================================================================================
Build Number 5.20171.291                 Build Date: 04/24/2017
=========================================================================================

* Improvements
    - Added border support for xlsx importing. (TFS 238473)

* Bug fixes
    - FlexSheet sorting of numbers on unbound sheet inconsistent. (TFS 253901)
    - [FlexSheet] Blank row gets added on sorting FlexSheet if allowAddNew is set to true.
      (TFS 255447)
    - 'filterApplied' event is not fired after the FlexSheet filter applied.
    - [PureJS][MultiRowIntro] Observed inconsistent behaviors in Paging MultiRow when adding 
      and deleting records. (TFS 252479)
    - keyboard backspace (delete on Mac) will delete data from a cell when is read-only.
      (TFS 256689)

=========================================================================================
Build Number 5.20171.290                 Build Date: 04/20/2017
=========================================================================================

* Bug fixes
    - Different Behavior in FlexGrid and FlexSheet with Del key and selectionMode equals 
      to Row. (TFS 253495)
    - FormatItem event gets fired twice for a condition in FlexSheet. (TFS 250287)
    - FlexSheet initialization issue. (TFS 252562)
    - Cell format 'D' in exported file is different from FlexGrid. (TFS 250498)

=========================================================================================
Build Number 5.20171.289                 Build Date: 04/18/2017
=========================================================================================

* Bug fixes
    - On sorting column containing formula, formulae does not get updated respectively.
      (TFS 252724)
    - The formulas in the selected row/column are not updated after insert rows/columns
      in FlexSheet. 
    - [Angular] If cell uses an edit template containing a Wijmo InputMask control, and cell
      editing is initiated with a key press, the caret can be positioned incorrectly.
    - The whole grid freeze when import Excel xlsx file containing frozen row. (TFS 252381)
    - Console error occurs when chart is inserted in unbound sheet and any row or 
      column is deleted. (TFS 252619)
    - 'getCellData' method does not return formatted value even when 'formatted' parameter 
      is set to true. (TFS 251730)
    - Observed mulitple issues when 'Paste' operation is done after filtering. (TFS 245353)

* Improvements
    - Wijmo components for React are reworked as classes inherited from the 
      React.Component class. This change doesn't bring any compatibility issues.

=========================================================================================
Build Number 5.20171.287                 Build Date: 04/09/2017
=========================================================================================

* Bug fixes
    - From now on, the name "Angular" in this document denotes Angular 2 or higher, 
      and "AngularJS" denotes Angular 1.x, according to the naming conventions
      described here:
      http://angularjs.blogspot.ru/2016/12/ok-let-me-explain-its-going-to-be.html#Naming_guidelines_48
    - [Angular] If cell uses an edit template containing a Wijmo input control, and cell
      editing is initiated with a key press, the caret is positioned before the text
      (should be after).
    - [Angular] In SPA working in IE, committing changes to FlexGrid.collectionView right
      before leaving the page with may cause an exception.
    - [FlexGrid][PDF] Tree indent is not applied anymore in exported PDF when export
      grouping grid to PDF. (TFS 252351)
    - Percentage format is imported to FlexSheet incorrectly. (TFS 252481)
    - Fixed the filter issue for the nested group row.
    - [Angular][ExcelImportExport] Unlike previous build, empty 'Discount' column is 
      observed in 'FlexGrid Import Export (JSZip3)' sample. (TFS 252401)

* Breaking Changes
    - Changed default style for FlexChart's minor grid line from dashed to solid.
      The new default looks better in most applications; if anyone prefers the
      old style, it can be restored with this CSS rule:
        /* old-style minor grid line */
        .wj-flexchart .wj-axis-x .wj-gridline-minor {
            stroke: black;
            stroke-dasharray: 6;
            stroke-width: 0.25px;
        }


=========================================================================================
Build Number 5.20171.285                 Build Date: 04/03/2017
=========================================================================================

* Improvements
    - Disable (rather than hide) ComboBox drop-down button when list is empty 
      This reduces flicker in some scenarios, especially in AutoComplete.
    - Improved keyboard handling/accessibility in MultiSelect control.
    - Added support for CTRL+A key to check/uncheck all items in MultiSelect
      and ListBox controls.
    - Library has been adapted to TypeScript 2.2.
    - Angular samples' package.json have been upgraded to Angular 4.
    - [wijmo.grid.xlsx] Added a possibility to perform custom cell content
      export (via IFlexGridXlsxOptions.formatItem callback).
      The Angular 2 ExcelImportExport sample, "FlexGrid Import Export (JSZip3)"
      page is updated to demonstrate the feature (check on the "Custom cell content"
      checkbox).
    - [Vue2] External modules for the Vue2 interop are included in Wijmo NpmImages
      (module names begin with "wijmo.vue2").
      Added the Vue2ExternalModules sample demonstrating how to use them with 
      WebPack 2 and SystemJS.
    - [React] External modules for the React interop are included in Wijmo NpmImages
      (module names begin with "wijmo.react").
      Added the ReactExternalModules sample demonstrating how to use them with 
      WebPack 2 and SystemJS.

* Bug fixes
    - [MultiRow] Aggregate values do not show in group header rows and footer row when 
      grouped by a column. (TFS 250099) 
    - Eliminated "<template> is deprecated" warning caused by Angular WjMenuItem and
      WjMenuSeparator components when used with Angular 4.

=========================================================================================
Build Number 5.20171.283                 Build Date: 03/17/2017
=========================================================================================

* Improvements
    - [wijmo.grid.pdf] Added customCellContent and formatItem properties to the
      IFlexGridDrawSettings interface.
    - [PdfExport sample] Added new samples: "Custom cell content",
      "Customize cell rendering" and "Drawing cells manually".
    - Added sumProduct formula in FlexSheet inbuilt formula. (TFS 237586)
    - Fixed a bug in the TreeView's childItemsPath getter function.
    - Optimized wijmo.grid.DataMap.getDisplayValue(key) performance.
    - Optimized grid touch operations when used with DragDropTouch polyfill.

* Bug fixes
    - Freeze button did not refresh when excel file with frozen pane was imported
      in ExcelBook NG2 sample. (TFS 247174)
    - Number string was formatted as number in the String-type columns. (TFS 243174)
    - When exporting Excel, the format of the first row of MultiRow was not honored.
      (TFS 240341)
    - Hidden rows/cols in fixed areas were skipped when importing. (TFS 238470)

=========================================================================================
Build Number 5.20171.282                 Build Date: 03/10/2017
=========================================================================================

* Bug fixes
    - Formula cells cannot copy and paste using 'Ctrl+X' key. (TFS 247587)

=========================================================================================
Build Number 5.20163.281                 Build Date: 03/09/2017
=========================================================================================


=========================================================================================
Build Number 5.20163.280                 Build Date: 03/08/2017
=========================================================================================

* Bug fixes
    - Auto-resize do not work properly for the last columns after imported excel file with 
      multiple columns. (TFS 247165)

=========================================================================================
Build Number 5.20163.279                 Build Date: 03/07/2017
=========================================================================================

* Bug fixes
    - 'Cannot read property 'binding' of undefined' error occurs on changing 'Item Count' 
      after filtered by a column in the sheet. (TFS 240046)
    - Observed multiple issues when copy and paste some functions(case 2). (TFS 239319)
    - Math Incorrect when Loaded FlexSheet Contains Empty Cells with Formatting. (TFS 240130)

=========================================================================================
Build Number 5.20163.278                 Build Date: 03/01/2017
=========================================================================================

* Improvements
    - Added pluralization feature to the wijmo.format method. 
      see http://wijmo.com/5/docs/topic/wijmo.Module.html#formatThe for details and 
      an example.

* Bug fixes
    - Multiple issues are observed on Mobile UI template when Tool menu is opened. (TFS 242884)
    - Hide unnecessary toolbar buttons from PdfViewer.
    - The settings in export bar are disappeared when reportviewer/pdfviewer size is changed.

=========================================================================================
Build Number 5.20171.275                 Build Date: 02/23/2017
=========================================================================================

* Improvements
    - [Angular 2] Every Wijmo component constructor now calls the special 'created'
      method. If you create a custom component inherited from a Wijmo component,
      and need to perform some initializations in its constructor then instead of
      declaring a constructor you can just override the 'created' method and perform
      initializations in it. This will prevent you from the necessity to maintain
      constructor parameters and keep them in synch with parameters of the base Wijmo
      component. The details of how Angular processes components inheritance can be
      found here: https://github.com/angular/angular/commit/f5c8e09
    - [Angular 2] Samples moved to Angular 2.4.

* Bug fixes
    - Fixed TypeScript version number in Angular 2 samples' package.json.

=========================================================================================
Build Number 5.20171.273                 Build Date: 02/21/2017
=========================================================================================

* Bug fixes
    - FlexSheet throws error when loading excel sheet with theme template. (TFS 240126)
    - Script error occurs on opening filter editor after changed 'itemsSouce' of the sheet.
      (TFS 240046)
    - Importing XLSX Files with Nested Functions Drops Parenthesis. (TFS 240129)
    - Observed multiple issues when copy and paste some functions. (TFS 239319)
    - Filtering do not work properly for Boolean type after cell merging. (TFS 240107)
    - When importing, also load the furigana. (TFS 239371)

=========================================================================================
Build Number 5.20171.271                 Build Date: 02/19/2017
=========================================================================================

* Bug fixes
    - Observed multiple issues when copy and paste some functions. (TFS 239319)
    - Context-menu of FlexSheet cannot be opened by 'Shift+F10' key combination. (TFS 239610)

* Improvements
    - Add mobile support to reportviewer control.  Added a thresholdWidth property to switch
      mobile or PC UI template.  If width of control is smaller than thresholdWidth, mobile UI will
      be applied.  If width of control is equal or greater than thresholdWidth, PC template
      will be applied.  If thresholdWidth is set to 0, then only PC template is applied and if
      it's set to a large number e.g. 9999, then only mobile template is applied.

=========================================================================================
Build Number 5.20171.270                 Build Date: 02/16/2017
=========================================================================================

* Improvements
    - Removed deprecated properties 'disabled' and 'required'. These were replaced
      in build 5.20162.192 with 'isDisabled' and 'isRequired', in order to avoid 
      conflicts with standard HTML attributes in the markup.
    - Added gradient color support in chart controls.
      (See FlexChartIntro sample for details).

* Breaking Changes
    - [Angular1/Angular2] An ngModel directive specified on a WjMultiSelect 
      directive/component is now mapped to the 'checkedItems' property, instead
      of the 'selectedValue' property.
      The previously used mapping to the 'selectedValue' property didn't have
      any practical sense, so this change should not hurt your code.

=========================================================================================
Build Number 5.20163.266                 Build Date: 02/13/2017
=========================================================================================

* Improvements
    - [Angular2] Restored CustomizedComponents sample.
    - [Angular2] Component metadata variables made typed using the IWjComponentMeta
      and IWjDirectiveMeta interfaces (for components and directives respectively).

* Bug fixes
    - Javascript error occurred when pasting while selecting cell range with mouse
      button pressed. (TFS 236200)
    - [wijmo.pdf] Fixed an issue that caused unicode characters in SVG image get
      garbled when drawing it via PdfDocumentArea.drawSvg method.

=========================================================================================
Build Number 5.20163.265                 Build Date: 02/09/2017
=========================================================================================

* Improvements
    - [Angular2] Improved Wijmo components inheritance experience.
      Every Wijmo component/directive now have a corresponding variable exported
      from the component's module that represents its @Component/@Directive decorator
      properties. The name of the variable is constructed as 
      <camel-case component class name>Meta. For example, wjInputNumberMeta variable
      represents metadata of the WjInputNumber component.
      Such a variable is useful when you create a custom component derived from a 
      Wijmo component, where you have to provide a @Component decorator whose properties
      should replicate most of the properties of the base class @Component decorator.
      
      Here's an example of the MyGrid component that inherits from the WjFlexGrid component,
      and adds 'myProperty' property and corresponding 'myPropertyChange' event:
        import { WjFlexGrid, wjFlexGridMeta } from 'wijmo/wijmo.angular2.grid';
        @Component({
            selector: 'my-grid',
            template: wjFlexGridMeta.template,
            inputs: [...wjFlexGridMeta.inputs, 'myProperty'],
            outputs: [...wjFlexGridMeta.outputs, 'myPropertyChange'],
            providers: [
                { provide: 'WjComponent', useExisting: forwardRef(() => MyGrid) },
                ...wjFlexGridMeta.providers
            ]
        })
        export class MyGrid extends WjFlexGrid {
            private _myProperty: string;
            myPropertyChange = new EventEmitter(false);

            constructor( @Inject(ElementRef) elRef: ElementRef,
                @Inject(Injector) injector: Injector,
                @Inject('WjComponent') @SkipSelf() @Optional() parentCmp: any,
                @Inject(ChangeDetectorRef) cdRef: ChangeDetectorRef) {
                super(elRef, injector, parentCmp, cdRef);
            }

            get myProperty(): string {
                return this._myProperty;
            }
            set myProperty(value: string) {
                if (this._myProperty !== value) {
                    this._myProperty = value;
                    this.myPropertyChange.emit(value);
                }
            }
        }

* Bug fixes
    - Some inconsistent behaviors found for paste operation when any column is copied and 
      pasted. (TFS 237260)
    - Chart is inserted on sheet when 'Enter' key is pressed in Formula bar. (TFS 237217)
    - Script error occurs when importing an Excel file which has no properties. (TFS 230954)
    - Cell selection is jumped when pressing context-menu key. (TFS 229848)
    - Javascript error occurred when perform paste operation while selecting cell range 
      and mouse click is not released. (TFS 236200)
    - 'Error: Two few parameters' shows when argument text for 'false' is not added in 
      logical formula 'IF'. (TFS 236529)
    - 'Find' and 'Search' formulas do not work and errors show when third parameter is 
      entered. (TFS 238043) 
    - Improved drag/drop to avoid clearing clipboard while dragging in IE11.

=========================================================================================
Build Number 5.20163.262                 Build Date: 02/03/2017
=========================================================================================

* Improvements
    - Added wijmo.nav module with the TreeView control.
      (See TreeViewIntro sample for details).
    - Added new MultiAutoComplete control to wijmo.input module (See InputIntro sample.) 
    - Added FlexGrid draggingColumnOver and draggingRowOver events to provide
      control over drop targets (e.g. prevent users from moving certain columns
      to certain positions).
    - Improved FlexGridFilter performance when displaying long value lists.
    - Added server-side support for wijmo.olap. To use server-side data providers,
      set the itemsSource property to a URL string pointing to a WebAPI service.

* Bug fixes
    - Date filters did not work correctly with ODataCollectionView when used with
      OData 4 sources (TFS 236203)
    - Extra cells with styles and borders are exported to xlsx format. (TFS 233929)
    - Angular 2: cell templates are not being drawn in a component with OnPush detection
      strategy. See also Breaking Changes.
    - Excel file generated using EPlus does not load in FlexGrid. (TFS 233881)
    - The whole pane is frozen when scroll down a bit, freeze at a location and sort a 
      column. (TFS 233584)
    - Working with Keys is not as expected for 'Insert Chart'. (TFS 233167)
    - Alphabetical characters in angle brackets "<>" cannot be seen in cell. (TFS 233105)
    - Script error occurs when importing an Excel file which has no properties. (TFS 230954)
    - Cell selection is jumped when pressing context-menu key. (TFS 229848)
    - Unable to import excel file generated from http://mockaroo.com/. (TFS 236285)

* Breaking Changes
    - Angular 2 WjFlexGrid component - added the following constructor parameter:
      @Inject(ChangeDetectorRef) cdRef: ChangeDetectorRef
      This change may affect your code in case if you use custom components derived 
      from WjFlexGrid. You need to add this last constructor parameter to these components 
      if this is the case.

=========================================================================================
Build Number 5.20163.259                 Build Date: 01/12/2017
=========================================================================================

* Improvements
    - Angular 1/2 PdfViewer samples replaced with PdfViewerIntro samples.

* Bug fixes
    - wijmo.culture.*.js files can be not correctly applied when used along with external
      modules.

* Breaking Changes
    - ReportViewer/PdfViewer - changed the value of serviceUrl property.
    The previous value should be like: http://c1webapihost/api, but now it should be like:
    http://c1webapihost/api/report.

=========================================================================================
Build Number 5.20163.257                 Build Date: 01/10/2017
=========================================================================================

* Improvements
    - The following modules can now work with JSZip 3: wijmo.xlsx, wijmo.grid.xlsx and 
      wijmo.grid.sheet. In addition to existing synchronous load/save methods that work 
      only with JSZip 2, the asynchronous loadAsync/saveAsync methods were added, 
      which require JSZip 3.
      The ExcelImportExport sample is updated to demonstrate the feature.  

=========================================================================================
Build Number 5.20163.256                 Build Date: 01/09/2017
=========================================================================================

* Bug fixes
    - Angular 2 interop regression: some child directives like WjFlexGridColumn are 
      incorrectly ordered in some scenarious.

=========================================================================================
Build Number 5.20163.255                 Build Date: 01/09/2017
=========================================================================================

* Improvements
    - Added Angular 2 version of the HeaderFilters sample.

=========================================================================================
Build Number 5.20163.254                 Build Date: 12/30/2016
=========================================================================================

* Bug fixes
    - NpmImages/wijmo-system-min folder contained modules in CommonJS format 
      (regression introduced in build 243).


=========================================================================================
Build Number 5.20163.252                 Build Date: 12/29/2016
=========================================================================================

* Bug fixes
    - FlexSheet: When copying and pasting cell/row ranges with filtering, some cell/row ranges
      get pasted incorrectly. (TFS 229225)
    - FlexSheet: Fixed undo/redo for editing cell or copy\paste issue.
    - FlexSheet: Cell style can be changed by hovering mouse over hidden popup area after escaping 
      'Styles' Popup via 'Esc' key. (TFS 229212)
    - FlexSheet: 'NaN' show in formula cells when deleting the row containing first reference cell 
      of the formula. (TFS 230274)
    - FlexSheet: Cell selection may change when pressing context-menu key. (TFS 229848)

=========================================================================================
Build Number 5.20163.251                 Build Date: 12/26/2016
=========================================================================================

* Bug fixes
    - Adding class name by the applyCellStyle method of FlexSheet doesn't work.
    - Observed multiple issues on deleting cells when more than one FlexSheet are placed 
      on the same page. (TFS 229804)
    - Error is observed on deleting the chart while still dragging the chart to a position.
      (TFS 229537)
    - Request for not setting font when includeCellStyles=false. (TFS 228252)

=========================================================================================
Build Number 5.20163.248                 Build Date: 12/22/2016
=========================================================================================

* Improvements
    - Improved FlexSheet support to copy/paste the content of the HeaderRow in the bound 
      sheet.

* Bug fixes
    - All cell values did not get deleted by pressing 'Delete' key when unbound sheet is 
      selected using 'Ctrl + A'. (TFS 229208)
    - Deleting the contents of whole sheet takes long time. (TFS 229499)
    - Request for not setting font when includeCellStyles=false. (TFS 228252)

=========================================================================================
Build Number 5.20163.247                 Build Date: 12/22/2016
=========================================================================================

* Improvements
    - Improved FlexGrid clipboard support to handle cells with line breaks.

* Bug fixes
    - Errors occur when undo deleting the chart after deleted exact row range. (TFS 227290)
    - Incorrect group header row still showing when filter the sheet by condition 
      'Equals to false'. (TFS 227297) 
    - If hide the first column and export the grouped FlexGrid to an Excel file, it becomes 
      corrupt Excel. (TFS 228209)
    - Editing cannot be canceled by pressing Esc key in bound/unbound sheet. (TFS 229194) 
    - 'Invalid sheet reference' error shows in cell when formula refer to other sheet.
      (TFS 229190)

=========================================================================================
Build Number 5.20163.246                 Build Date: 12/20/2016
=========================================================================================

* Bug fixes
    - Checkbox is shown in disable state when merging the boolean data-type column after 
      filtering is applied. (TFS 224995)
    - Random values do not show randomly when copying the cell which has the '=rand()' 
      formula. (TFS 224966)

=========================================================================================
Build Number 5.20163.245                 Build Date: 12/19/2016
=========================================================================================

* Bug fixes
    - FlexSheet flicker when select and paste a cell from clipboard after filtered by a 
      column. (TFS 228007)
    - 'countif' formula does not work as expected. (TFS 227926)
    - Inconsistent behavior of Ng2 WjItemTemplate when used in ComboBox.
    - Empty chart shows when delete the first column containing the selected cell range 
      of inserted chart. (TFS 227278)

=========================================================================================
Build Number 5.20163.243                 Build Date: 12/15/2016
=========================================================================================

* Improvements
    - Added a FlexGridDetailProvider.isAnimated property to enable animated transitions
      when showing row details.
    - Added a Control.rightToLeft property that determines whether the control is hosted
      in an element with right-to-left layout.
    - Improved showPopup method to handle screen boundaries when reference is a point.
    - Added RTL support to LinearGauge and BulletGraph controls. 
      The gauges now take RTL into account when rendering and handling the keyboard.
      The new behavior is compatible with the input element's when type="range".
    - Wijmo *culture.js files can be loaded before wijmo.js now.

* Bug fixes
    - [MultiRow][Pdf] Unlike previous build, top-left cell is not exported to Pdf
      format. (227233)
    - Fixed merge cells issue when export to xlsx file. 

=========================================================================================
Build Number 5.20163.240                 Build Date: 12/06/2016
=========================================================================================

* Improvements
    - Added support for Angular 2 Ahead-of-Time compiler. 
      .metadata.json files for Wijmo Angular 2 components are added to NpmImages'
      subfolders.
      Check also Breaking Changes section. 
    - Angular 2 specific properties (like isInitialized) and events 
      (like 'initialized'/valueChangedNg/etc) of Wijmo components are now exposed in 
      class declarations in .d.ts and hence available for Intellisense.
* Bug fixes
    - The spaces of the text are removed when export FlexGrid to excel.

* Breaking Changes
    - @WjComonent decorator is removed from the library, because AoT compiler
      doesn't support custom decorators.
    - A suffix in implementation names of Angular incarnations of Wijmo events
      has been changed from 'Wj' to 'Ng' (e.g. valueChangedWj became valueChangedNg).
      Note that these events was not officially documented and their direct usage was 
      not presumed.
    - A suffix in implementation names of Angular property change events (intended to
      implement two-way binding) has been changed from 'Ng' to 'PC' 
      (e.g. valueChangeNg became valueChangePC).
      Note that these events was not officially documented and their direct usage was 
      not presumed.

=========================================================================================
Build Number 5.20163.239                 Build Date: 12/04/2016
=========================================================================================

* Improvements
    - Added support for Angular 2.2.
    - Added a getCellElement method to the wijmo.grid.GridPanel class to retrieve the
      HTMLElement that represents a given cell in the panel.
    - Added Menu.show method to display the menu at arbitrary positions on the screen
      (context-menu style).
    - Added a twoDigitYearMax property to the culture calendar so users can control the
      threshold used for converting two-digit year strings into full years.
      e.g. 
            // changing threshold to 2100, so all values are parsed as 20**
            wijmo.culture.Globalize.calendar.twoDigitYearMax = 2100;
            var dt = wijmo.Globalize.parseDate('30/12', 'yy/MM'); // Dec 2030
    - Added support for showing group *and* column headers in the MultiRow control.
      This is done by setting the collapsedHeaders property to null (rather than true 
      or false).

* Bug fixes
    - Script error occurs on applying font, styles or formatting when there is no cells 
      in the sheet. (TFS 222114)
    - 'Positive number expected' error occurs when insert a chart type in the empty sheet.
      (TFS 222126)
    - Unlike FlexGrid, data values from collapsed group are not shown in the value filter 
      list of filter editor. (TFS 221920)
    - GroupHeader exported with encoded HTML to excel. (TFS 220929)
    - All sheets are selected when opening xlsx file in MS Excel. (TFS 221408)
    - Cell formats change from date to number when add/subtract days in date formulas 
      '=Today()' or '=Now()'. (TFS 222324)
    - Observed multiple issues when setting 'columnCount' and 'rowCount' properties in 
      the sheet containing groups. (TFS 222693)
    - New added value (number/string value cell range) cannot be deleted properly when 
      inserting new columns. (TFS 221776)
    - Script errors occur when delete column/row ranges after insert a chart. (TFS 222078)
    - [FlexSheet][Pdf] Column-header row containing checkbox is exported to Pdf. (TFS 222643)
    - Fixed the issue the formula is updated incorrectly when delete rows\columns in the 
      FlexSheet.
    - Adding the first row with FlexGrid.newItemAtTop moved the new row template to the 
      bottom.

=========================================================================================
Build Number 5.20163.237                 Build Date: 11/17/2016
=========================================================================================

* Improvements
    - [FlexGridPdfConverter] added support for FlexSheet.
    - Added support for dataMaps on Boolean FlexGrid columns.
    - Added a dataMap property to the wijmo.grid.filter.ColumnFilter class.
      This dataMap takes precedence over the owner column's DataMap and 
      is used to provide the strings displayed by the filter editors.
      For example, it can be used to change the strings displayed for Boolean
      column filters from 'true/false' to 'yes/no'.
    - Improved FlexGrid performance when binding to large collections and not
      limiting grid height (automatically sized grids). This used to cause
      poor performance since the grid only took its host element into account
      when virtualizing cells; now it also takes into account the browser
      window.

* Bug fixes
    - [MultiRowExplorer] Fixed alignment in PDF export. (TFS 204780)
    - Calendar did not handle min/max on the same month properly (TFS 221061)

* Breaking Changes
    - Added an optional 'fn' parameter that was missing in the wijmo.removeEventListener
      method. This will only break code that called removeEventListener specifying 
      all optional parameters, which should be rare. The change provides more control
      over event removal and consistency with the wijmo.addEventListener method.

=========================================================================================
Build Number 5.20163.234                 Build Date: 11/10/2016
=========================================================================================

* Bug fixes
    - Fixed issues in ReportViewerIntro sample. (TFS 220470)

=========================================================================================
Build Number 5.20163.233                 Build Date: 11/09/2016
=========================================================================================

* Improvements
    - Added new samples for the wijmo.viewer module:
        -- PdfViewerIntro (Pure JS)
        -- ReportViewerIntro (Pure JS, Angular 1/2)

=========================================================================================
Build Number 5.20162.231                 Build Date: 11/06/2016
=========================================================================================

* Breaking Changes
    - Box & Whisker chart implemented as series extension BoxWhisker in chart.analytics
      module.

=========================================================================================
Build Number 5.20162.229              Build Date: 11/02/2016
=========================================================================================

* Bug fixes
    - [PDF] Rendered image size is reduced. (TFS 218011)
    - Any cell formats cannot apply in unbound sheet for FlexSheet. (TFS 218004)
    - Decimal values show full precision when set cell data in unbound sheet. (TFS 218072)

=========================================================================================
Build Number 5.20163.228              Build Date: 10/31/2016
=========================================================================================
* Improvements
    - Update descriptions in ReportViewer and ReportViewerIntro samples (PureJS).

* Bug fixes
    - Group headers and glyphs are not shown in group header rows in FlexSheet. (TFS 215399)
    - Download failed error thrown on exporting PDF in chrome browser. (TFS 207666)
    - Incorrect date format show in editing mode. (TFS 215532)
    - ReportViewer, the window will scroll to the topmost on clicking the bookmark or exiting the full screen mode.
    - Exporting & Printing do not work. (TFS 214838)
    - Viewer and pdf document are not shown properly in printed file 
      when print using browser printing. (TFS 214846)

* Breaking Changes
    - NpmImages zip folder
        -- Folders containing minified files now have '-min' suffix in their names,
           e.g. wijmo-amd is renamed to wijmo-amd-min.
        -- Files in these folder has no .min suffix in their names anymore, e.g.
           wijmo.min.js became wijmo.js.

=========================================================================================
Build Number 5.20162.227              Build Date: 10/27/2016
=========================================================================================

* Improvements
    - Improved support for filtered DataMaps with duplicate display values
    - Added ability to export the FlexGrid.columnFooters panel to PDF (TFS 208282).

* Bug fixes
    - Format property was not applied to Aggregate values on MultiRow footer rows (TFS 214420)
    - Script error is observed when copying an empty cell. (TFS 214864)
    - Cell which has value '0' cannot be deleted. (TFS 214858)
    - If import an Excel file that uses the display format that has not been registered, 
      the abnormal termination. (TFS 214551)
    - Sheet page navigator UI is not shown correctly and it does not work properly in 
      Right to Left mode. (TFS 214877)
    - Incorrect values appear in empty cell when input space into a cell in unbound sheet.
      (TFS 215108)
    - Screenshot images are missing in the samples. (TFS 214472)
    - The merged cell copy\paste doesn't work in FlexSheet. (TFS 215081) 

=========================================================================================
Build Number 5.20162.226              Build Date: 10/19/2016
=========================================================================================

* Improvements
    - Added five new settings to the wijmo.olap.PivotField.ShowAs enumeration:
        PctGrand, PctCol, PctRow, RunTot, and RunTotPct.
      These new settings are compatible with similar settings available in Excel.
    - Added 'showFilterIcons' property for FlexSheet.  User is able to show/hide the filter
      icons in the Column Header of FlexSheet by this property. (TFS 214354)

* Bug fixes
    - 'Listbox' selection cannot be copied correctly when selecting non-adjacent rows.
      (TFS 213425)
    - The vertical scroll position of the FlexSheet was reset to 0 after resizing the
      columns of the FlexSheet.
    - Resizing rows does not work properly after deleting all columns. (TFS 213819)
    - Extra freeze bars are shown in headers of the sheet when freeze the sheet at a 
      certain position. (TFS 214147)
    - Observed multiple UI issues in the sample. (TFS 214113)
    - ReportViewer control does not show in sample page and console error occurs. (TFS 214345).
    - Observed multiple issues when setting 'Continuous Page View' 
      and 'Full Screen' (TFS 214334).
    - Automatically formats numbers entered in a cell to Decimal. (TFS 214361)

=========================================================================================
Build Number 5.20162.225              Build Date: 10/17/2016
=========================================================================================

* Improvements
    - Added a new wijmo.viewer module that includes two controls:
        -- ReportViewer: displays server-side generated FlexReport and SSRS reports.
        -- PdfViewer: displays PDF files using a server-side service.
      Added ReportViewer and PdfViewer samples to show how to use the new controls.
    - Added ability to skip columns of FlexGrid during exporting to Excel. (TFS 195426)

* Bug fixes
    - The content of the column header of FlexSheet was displayed incorrectly.

=========================================================================================
Build Number 5.20162.223              Build Date: 10/16/2016
=========================================================================================

* Improvements
    - Added ability to skip columns of FlexGrid during exporting to Excel. (TFS 195426)

* Bug fixes
    - Script error is observed when deleting all columns via context menu of unbound sheet 
      in a certain scenarios. (TFS 212622) 
    - Setting 'aggregate' property of columns was not working correctly. (TFS 209838)
    - FlexGrid clipboard operations did not handle SelectionMode properly.
    - Angular 2: ngAfterViewInit is not called in a component derived from a Wijmo component.

=========================================================================================
Build Number 5.20162.222              Build Date: 10/10/2016
=========================================================================================

* Improvements
    - Angular 2 samples in the Wijmo Enterprise Evaluation build now install Wijmo
      modules from an online location (instead of a local one used in the rest of builds).
      A corresponding record in package.json files now looks like this:
      "dependencies": {
          "wijmo": "http://prerelease.componentone.com/wijmo5/npm-images/C1Wijmo-Enterprise-Eval-AMD-5.20162.222.tgz",
          ... another libraries
      }
      Due to this change, the samples from Wijmo Enterprise Evaluation build can be 
      freely moved to a new location now without a necessity to correct Wijmo reference
      in package.json.

* Bug fixes
    - Script error occurs and Excel file cannot be exported when exporting empty pivot 
      view to Excel 'xlsx' format. (TFS 210188)
    - Undo/redo is not working correctly after copy and paste multiple cell/row ranges.
      (TFS 211362)
    - Alternating rows and freeze bar do not show correctly when filtering the frozen 
      sheet. (TFS 211076) 
    - Color palette cannot be loaded into the sheet and workbook viewer. (TFS 210946)
    - Script error is observed when dragging on empty sheet after deleting the columns in 
      unbound sheet. (TFS 210916)
    - Error is observed when navigating to other sample when formula dropdownlist is 
      still opened. (TFS 210924)
    - Charts cannot be inserted into the sheet when select the cell ranges containing 
      different cell count. (TFS 211345) 

=========================================================================================
Build Number 5.20162.218              Build Date: 10/04/2016
=========================================================================================

* Improvements
    - Added external module versions of Wijmo core modules.
      Wijmo download zip now includes NpmImages folder with the wijmo-amd, wijmo-commonjs 
      and wijmo-system subfolders containing Wijmo modules in AMD, CommonJS and System
      formats respectively.
      Each of these folders is effectively an NPM image that can be installed using the
      npm install <path to a folder>
      command. Alternatively, a corresponding record can be added to an application's 
      package.json file that will cause Wijmo installation from a local folder to the
      application's node_modules/wijmo folder, when "npm install" command is executed
      in the application's root folder. For example:
      "dependencies": {
          "wijmo": "../../../../../NpmImages/wijmo-amd",
          ... other libraries
      }

      Currently only Wijmo core and Angular 2 interop modules are represented as 
      external modules in these folders, the rest of interops are shipping as 
      conventional global modules. 
      The culture files (wijmo.culture.<culture_code>) are global modules too, 
      and should be used in conjunction with Wijmo external modules in the same way
      as they are used with global modules - by adding them to HTML page using <script> 
      tag, or in dynamic scenarious by loading them using XMLHttpRequest.

      One important remark regarding Angular 2 interop modules. Those were external
      modules from the day one, and referenced Wijmo core modules via global 'wijmo' 
      variable (e.g. wijmo.grid.FlexGrid). The Angular 2 interop modules under the 
      NpmImages folder are different: they reference Wijmo core external modules
      using the TypeScript "import" statement (that transpiles to the appropriate
      JavaScript code depending on the current module format). For example:
      import * as wjcGrid from 'wijmo/wijmo.grid';

      Module names follow the same convention as Angular 2 interop modules,
      i.e. 'wijmo/' prefix followed by a module name, e.g. 'wijmo/wijmo', 
      'wijmo/wijmo.input', 'wijmo/wijmo.grid'.

      Wijmo Angular 2 samples are reworked to use external versions of Wijmo core modules.
      Their package.json file includes a reference to the NpmImages/wijmo-amd folder 
      (as shown in the example above) that causes an automatic installation of all necessary 
      Wijmo code in the node_modules/wijmo folder when you issues an "npm install" command. 
      Note that this definition works only if you use it from its original location in the
      Wijmo zip image. If you move a sample to a new location then you need to correct 
      this path in the sample's package.json.

      The rest of the samples continue to use conventional global modules.

=========================================================================================
Build Number 5.20162.216              Build Date: 09/29/2016
=========================================================================================

* Improvements
    - Add word wrap support for saving/loading xlsx file. (TFS 205565)
    - Replaced character-based pencil and asterisk icons used to indicate 
      edit mode/new template in FlexGrid rows with new glyphs: "pencil" and "asterisk".
      This makes it possible to hide or customize the icons using CSS.
    - Added FlexGrid.rowEditStartingStarted events to complement the rowEditEnding/Ended
      events which were already available. Also made rowEditEnding/Ended events fire
      when canceling edits. These changes make it easier to implement custom behaviors
      such as edit mode indicators and deep-binding edit undos.
    - Improved FlexGrid.beginningEdit event parameters to set the "data" event parameter
      to the event that caused the grid to enter edit mode (usually a keyboard or mouse
      event, or null if the editing was initiated by a call to the startEditing event)

* Bug fixes
    - FlexSheet row height of was lost on exporting to Excel. (TFS 205565)

=========================================================================================
Build Number 5.20162.215              Build Date: 09/28/2016
=========================================================================================

* Improvements
    - Added a new BoxPlot ChartType to the FlexChart control. It represents Box & Whisker
      charts. An example is uncluded in the FlexChartIntro sample.

=========================================================================================
Build Number 5.20162.214              Build Date: 09/27/2016
=========================================================================================

* Bug fixes
    - Marquee is overlapped over inserted chart. (TFS 210075)

* Improvements
    - Improved FlexGrid column auto-generation to handle fields that contain null values

=========================================================================================
Build Number 5.20162.212              Build Date: 09/26/2016
=========================================================================================

* Improvements
    - Added Vue2 interop (wijmo.vue2.js) https://vuejs.org/2016/04/27/announcing-2.0/
    - Added support for wijmo.olap controls to Vue/React interops
    - Added Vue/React versions of the OlapIntro sample
    - Added validation support to CollectionView (CollectionView.getError property)
      and to FlexGrid (FlexGrid.showErrors and FlexGrid.validateEdits properties).
      When showErrors is set to true, the grid shows validation errors on row headers and cells.
      When validateEdits is set to true, the grid remains in edit mode while there are validation errors.

* Breaking Changes
    - Changed the arguments of the cellEditEnding event from CellRangeEventArgs to 
      CellEditEndingEventArgs, which extends the former with a 'stayInEditMode' member.
      Any code that calls the onCellEditEnding event raiser should be updated as follows:
            // raise grid's cellEditEnding event
            //var e = new wijmo.grid.CellRangeEventArgs(grid.cells, this._rng);
            var e = new wijmo.grid.CellEditEndingEventArgs(grid.cells, this._rng);
            grid.onCellEditEnding(e);
    - FlexSheet: Changed .wj-header-row font and background colors.  To get old styles
      reset values to: background-color: #4800ff !important; color: #ff6a00 !important;

* Bug fixes
    - Decimal values show full precision when enter numeric formulas. (TFS 208259)
    - Footer panel cannot be exported to Excel XLSX format. (TFS 208269)
    - Filtering is cleared on entering a formula into a cell in a certain scenario.
      (TFS 208825)
    - Formulae cells were not updated if cell data was set using setCellData method.
      (TFS 208469)

=========================================================================================
Build Number 5.20162.211              Build Date: 09/15/2016
=========================================================================================

* Bug fixes
    - Some missing content added to WijmoHelp.

=========================================================================================
Build Number 5.20162.210              Build Date: 09/15/2016
=========================================================================================

* Improvements
    - Added support for Angular 2 Release (2.0.0).

=========================================================================================
Build Number 5.20162.209              Build Date: 09/14/2016
=========================================================================================

* Improvements
    - Added support for Vue 2 (requires version RC.6).

=========================================================================================
Build Number 5.20162.208              Build Date: 09/14/2016
=========================================================================================

* Improvements
    - Angular 2: ported to RC.7 (interop and samples)

=========================================================================================
Build Number 5.20162.207              Build Date: 09/06/2016
=========================================================================================

* Improvements
    - Angular 2: all samples ported to RC.6

=========================================================================================
Build Number 5.20162.206              Build Date: 09/05/2016
=========================================================================================

* Improvements
    - Angular 2: Explorer sample is ported to RC.6

=========================================================================================
Build Number 5.20162.205              Build Date: 09/04/2016
=========================================================================================

* Improvements
    - Angular 2: FinancialChartExplorer sample ported to RC.6

=========================================================================================
Build Number 5.20162.204              Build Date: 09/01/2016
=========================================================================================

* Improvements
    - Angular 2: Wijmo interop adapted to RC.6, and can still work with RC.5.
      The following samples was moved to RC.6: 
        InputIntro 
        FlexGridIntro
        FlexSheetExplorer.
      The following samples were reworked for NgModules but still use RC.5:
        FlexChartIntro
        FlexPieIntro
        CollectionViewIntro
        CellTemplateIntro
        FinancialChartIntro
        FlexSheetIntro
        MultiRowIntro

=========================================================================================
Build Number 5.20162.203              Build Date: 08/31/2016
=========================================================================================

* Improvements
    - Improved keyboard support in wijmo.Menu. Now users can use the keyboard to open 
      the menu with (Enter/f4/alt+up/alt+down) and to navigate the options (up/down/
      autosearch).
    - Angular 2: added support for NgModule system introduced in RC.5. Each Wijmo
      Ng2 module includes corresponding NgModule that represents the module in Ng2
      application and exports all its components. NgModule's name is inferred from
      ES6 module name, e.g. for ES6 module wijmo/wijmo.angular2.grid.filter
      the name of corresponding NgModule is WjGridFilterModule.
      Only few samples are reworked so far to use NgModel: InputIntro, FlexGridIntro,
      ngForms and FlexSheetExplorer. The latter is SPA application that implements
      lazy modules loading.

* Bug fixes
    - Searching is not working correctly at second time in filter by value editor. 
      (TFS 204947)
    - Excel file is corrupted when export MultiRow after add a new row containing 'NaN' 
      cells. (TFS 204946)
    - Conditional filtering without setting filter value does not work properly in unbound
      sheet. (TFS 204380)
    - Group header cells cannot be entered into editing mode in FlexSheet. (TFS 205648)

=========================================================================================
Build Number 5.20162.202              Build Date: 08/25/2016
=========================================================================================

* Improvements
    - Angular 1/2: added support for cell templates for FlexGrid column footers.
      WjFlexGridCellTemplate.cellType property now accepts 'ColumnFooter' and 'BottomLeft'
      to be applied to the corresponding cell types.
      In order to get a cell value in 'ColumnFooter' cell templates the $value (Angular 1)
      or cell.value (Angular 2) properties can be used.
    - Added a Gauge.showTicks property that causes linear and radial gauges to show
      tick marks on the gauge face. The tick marks start from "min" to "max" at every "step".
      By default, the tick marks are white and 2 pixels in thickness. They can be styled 
      using a ".wj-gauge .wj-ticks" CSS selector to customize their "stroke" and "stroke-width"
      values.
    - The FlexGridPdfConverter class now supports MultiRow. (TFS 204780)

* Bug fixes
    - FlexSheet does not handle the clipboard properly. (TFS 204530)
    - Aggregate cells from group header rows cannot be deleted by pressing 'Delete' 
      key. (TFS 200935)
    - Filter values list shows merged cell contents unlike MS-Excel. (TFS 199443)
    - Filtering remains applying in old column when drag and drop filtered column to new 
      position. (TFS 200934)
    - Currency and Percentage format of the Cell in MultiRow control cannot be exported 
      correctly to Excel format. (TFS 204796)
    - Filtering is not retained when unfreeze the frozen pane. (TFS 204887)
    - When Culture is set to Japanese, date and currency columns are not exported correctly
      to Excel format. (TFS 204797)

=========================================================================================
Build Number 5.20162.201              Build Date: 08/23/2016
=========================================================================================

* Improvements
    - Added support for column footers panel on the FlexGrid.
      Column footers have their own 'columnFooters' grid panel (similar to columnHeaders 
      and rowHeaders). To add column footers to a grid, add one or more rows to its
      columnFooters panel. For example:
        grid.columnFooters.rows.push(new wijmo.grid.GroupRow())
      In this example, we added a GroupRow, which will cause the grid to automatically
      display the aggregates set in each Column.
      Alternatively, you could add on or more regular rows, and set the cell contents of 
      those row using the columnFooters.setCellData method:
        grid.columnFooters.rows.push(new wijmo.grid.Row());
        grid.columnFooters.setCellData(0, 0, 'column footer value');

* Bug fixes
    - Alphabetic characters cannot be entered in date and numeric columns after imported an 
      Excel file. (TFS 204082)
    - Filter by value is not working correctly when filter by value twice in the same 
      column. (TFS 204339)
    - FlexSheet cross-sheet formulas don't update in other sheets when value is changed. 
      Only update when the cell containing the formula is double-clicked. (TFS 203786)
    - Console error occurs and filter editor cannot be opened when the sheet is frozen.
      (TFS 204376)
    - Error occurs on opening filter editor after load an empty Excel file into the 
      FlexSheet. (TFS 204385)

=========================================================================================
Build Number 5.20162.200              Build Date: 08/18/2016
=========================================================================================

* Improvements
    - Improved the layout of the on-line help system.
    - Added a new interop module for React: wijmo.react.js.
    - Added a new interop module for Vue: wijmo.vue.js.
    - Added a new FlexGrid.newRowAtTop property to control whether the new row template
      should be displayed at the top or at the bottom of the data rows.
    - Improved FlexGrid scrolling with frozen cells (used to be a little jerky in IE).
    - Improved performance of Row/Col.IsSelected method.
    - Improved performance of FlexGrid.preserveOutlineState property.
    - Added an optional 'dataItem' parameter to the DataMap.getDisplayValues method.
      The dataItem can be used to restrict the list of display values based on properties
      of the data item being rendered/edited (see http://wijmo.com/topic/flexgrid-datamap-that-is-row-dependent/).
    - Angular 2 - added the autoSizeRows boolean property to the wjFlexGridCellTemplate
      directive that allows to disable automatic row height expansion.
    - Added support for "deep-binding" to the ListBox control (e.g. "customer.name").
    - Add a new charting control: FlexRadar for creating radar and polar charts. 
      The control is in new module: wijmo.chart.radar.js.
      FlexRadarIntro samples (PureJs, Angular 1/2) are added to demonstrate the new
      control's features.

* Bug fixes
    - Filter editor does not open and console error occurs after load an Excel file which 
      contains hidden rows and columns. (TFS 201600)
    - The 'collapsed' state of the row is wrong after exporting to xlsx file. 
    - Angular 1/2 - a cell of a hierarchical FlexGrid (with childItemsPath defined) can't
      be edited if a cell template is applied to the cell.
    - Angular 2 - fixed problem with FlexGrid.autoSizeRows/autoSizeColumns methods with
      templated cells.
    - FlexGrid export row's fill color changes into blue. (TFS 202707)
    - groupHeaderFormat can't be applied when exporting to Excel. (TFS 202908)
    - Some events of FlexSheet control do not fire properly. (TFS 202760)

=========================================================================================
Build Number 5.20162.198              Build Date: 08/02/2016
=========================================================================================

* Improvements
    - Rewrote parts XLSX module to no longer include xlsx.js dependency. This allowed us 
    to remove the restricitve Microsoft copyright and license.

* Bug fixes
    - Exported excel files are corrupted when export FlexGrid content to Excel format.
      (TFS 201534)
    - Filter editor does not open and console error occurs after load an Excel file which 
      contains hidden rows and columns. (TFS 201600)

=========================================================================================
Build Number 5.20162.196              Build Date: 07/21/2016
=========================================================================================

* Bug fixes
    - 'IndexSizeError' occurs on navigating to the right using keyboard after merged last 
      row or all cells. (TFS 199427)
    - FlexSheet controls cannot render and script errors occur. (TFS 199777)
    - Remove selection when clicking empty area of FlexChart with selectionMode set to Point.

=========================================================================================
Build Number 5.20162.194              Build Date: 07/18/2016
=========================================================================================

* Bug fixes
    - Script error occurs on performing ‘undo’ after drag and drop columns/rows with 
      'Shift' key pressed. (TFS 199376)

=========================================================================================
Build Number 5.20162.192              Build Date: 07/12/2016
=========================================================================================

* Improvements
    - Angular 2: added support for Angular forms. The ngForms sample demonstrates the 
      feature.
      The implementation is based on the *new* forms implementation from the @angular/forms 
      module, instead of *deprecated* forms stuff from the @angular/common module – 
      see the documentation on the new forms stuff here: 
      https://angular.io/docs/ts/latest/guide/forms.html .
      The dynamic forms scenario described here
      https://angular.io/docs/ts/latest/cookbook/dynamic-form.html
      is supported as well. The ngForms sample includes the modified
      version of the abovementioned Dynamic Forms example that uses
      Wijmo input components.
    - Angular 2: tested against RC.4.
    - Added a few class names to FlexGrid elements to enable more flexible CSS-based
      styling. The new class names are:
        wj-elem-collapse  Element that holds the expand/collapse glyphs in group rows
        wj-elem-dropdown  Element that holds the drop-down glyph in data-mapped cells
        wj-elem-filter    Element that holds the filter glyph in column headers
    - Added a "wj-autocomplete-match" class to define the default style used for 
      highlighting AutoComplete matches (can be overridden by the cssClass property).
    - Added an AutoComplete.searchMemberPath property that allows you to specify 
      item properties to use when searching (in addition to displayMemberPath).
    - Added an 'isReadOnly' property to all input controls (DropDown, InputNumber, Calendar).
      This prevents users from changing the value, but still allows selection, focus, and events.
      It is equivalent to the 'readonly' property in HTML input elements, but also prevents
      editing with the mouse (drop-downs, buttons, wheel).
    - Added a selectionMode property to the InputDate and Calendar controls to allow 
      selecting months rather than specific days.
    - Added specific class names to derived controls (for example, the ComboBox control host
      element now has class wj-combobox in addition to wj-control and wj-dropdown).
    - Improved CSS to keep InputDate calendar width constant as the user navigates months
      in IE.
    - Made input controls switch the 'for' attribute of labels targeting the host element 
      so they target the inner input element instead. For example:
          <label for="inputDate">Departure:</label>
          <wj-input-date id="inputDate"></wj-input-date>
      The InputDate will automatically set the id to its inner input element to 'inputDate.input'
      and will switch the "for" attribute of the label to target the input element instead.
    - Added undo/redo processing for inserting/removing chart in FlexSheet. (TFS 191085)
    - Added a new 'wj-state-empty' class to controls that contains empty input elements.
      This class can be used in CSS selectors along with the wj-state-focused class.
    - Allow empty strings on masked inputs when "isRequired" is false.

* Breaking changes
    - Replaced some custom attributes used by the FlexGrid control with class names 
      for better W3C compliance and CSS support:
        "wj-collapse" attribute was replaced with "wj-elem-collapse" class name
        "wj-dropdown" attribute was replaced with "wj-elem-dropdown" class name
        "wj-filter" attribute was replaced with "wj-elem-filter" class name
      This change may affect applications that customize the display of node cells.
      For example, you should replace:
        cell.innerHTML = '<span wj-collapse class="glyphicon ...
      With
        cell.innerHTML = '<span class="wj-elem-collapse glyphicon ...
    - Deprecated 'disabled' and 'required' properties on all controls and replaced them
      with 'isDisabled' and 'isRequired'. This avoids conflicts with HTML attributes
      in markup. The old properties still work, but will be removed in a future release,
      so this is not a breaking change yet, but will be.

* Bug fixes
    - 'Year Quarter' and 'Fiscal Year Quarter' formats cannot be exported correctly to XLSX 
      file. (TFS 197681)

=========================================================================================
Build Number 5.20162.188              Build Date: 06/29/2016
=========================================================================================

* Improvements
    - Added wijmo.chart.hierarchical.Sunburst control. The control displays hierarhical 
      data as multi-level pie charts.
    - Added wijmo.chart.analytics.Waterfall class. The Waterfall series represents data
      values with cumulative effects(Waterfall chart).
    - wijmo.pdf - added support for drawing SVG images (the PdfPageArea.drawSvg method).
    - Added customized filter for FlexSheet, make the filtering behave exactly like in Excel.
    - Updated the cell ranges processing in formula that Insert/delete row/column will update 
      affected cell ranges in formulas.
    - Added a CollectionView.sortComparer property to support using custom value 
      comparers such as Dave Koele's "natural sorting": http://www.davekoelle.com/alphanum.html
    - Added JavaScript Intellisense support, see the Intellisense folder in Wijmo zip.
    - Angular 2 - adapted to Angular 2 RC.3
    - Angular 2: the 'initialized' event and 'isInitialized' boolean property are added
      to all components. The event triggers when the bindings on the component and all
      its child components have been initialized, and the property changes its value
      from false to true at this moment.
      Note that 'isInitialized' is a dynamic property, in a sense is that it's not 
      exposed as a TypeScript property out of the component interface, so it should be
      read using the component['isInitialized'] syntax.

* Bug fixes
    - When undo the current cell in editing mode with 'Ctrl + Z', original value is not 
      restored in editing cell. (TFS 189582)
    - Filtering by conditions (Equals and Does not equal) is not working correctly in Date,
      Numeric and Checkbox columns. (TFS 190543)
    - Angular 1/2: FlexGrid row heights may grow infinitely if grid performs cells merging
      and uses cell templates.
    - FlexSheet Filter values list does not include only items that are not excluded by 
      other filters like FlexGrid. (TFS 194375)
    - FlexSheet Filtering is cleared unintentionally in unbound sheet when insert/delete 
      column or row. (TFS 194311)
    - Sheets navigation is not working correctly when there is many sheets and direction 
      of the FlexSheet is Right To Left. (TFS 192724)
    - FlexSheet filtering is cleared unintentionally when sorting a column. (TFS 195517)
    - Formula drop-down cannot be opened by entering "=" if SelectionMode is set to 
      non-default value. (TFS 195513)
    - Sheet tabs and new sheet tab are not able to see in Right to Left sheet. (TFS 196273)
    - Incorrect values are shown in formula cells when delete a cell from formula cell 
      range. (TFS 197166)
    - Undo/redo action cannot be done at once after Inserting/deleting rows/columns like 
      MS-Excel. (TFS 197005)
    - Sheets navigation is not working correctly in IE and FireFox when there is many 
      sheets and direction of the FlexSheet is Right To Left. (TFS 192724)

=========================================================================================
Build Number 5.20161.171              Build Date: 06/24/2016
=========================================================================================

* Improvements
    - Wijmo for Angular 2 is adapted for RC.3.
    - Angular 2: the 'initialized' event and 'isInitialized' boolean property are added
      to all components. The event triggers when the bindings on the component and all
      its child components have been initialized, and the property changes its value
      from false to true at this moment.
      Note that 'isInitialized' is a dynamic property, in a sense is that it's not 
      exposed as a TypeScript property out off the component interface, so it should be
      read using the component['isInitialized'] syntax.
    - Added a CollectionView.sortComparer property to support using custom value 
      comparers such as Dave Koele's "natural sorting": http://www.davekoelle.com/alphanum.html

* Bug fixes
    - Angular 1/2: FlexGrid row heights may grow infinitely if grid performs cells merging
      and uses cell templates.

=========================================================================================
Build Number 5.20161.164              Build Date: 06/15/2016
=========================================================================================

* Bug fixes
    - Columns option not working for FlexSheet. (TFS 192100)

=========================================================================================
Build Number 5.20161.163              Build Date: 06/14/2016
=========================================================================================

* Improvements
    - Angular 2: refined component initialization functionality.

=========================================================================================
Build Number 5.20161.162              Build Date: 06/14/2016
=========================================================================================

* Breaking changes
    - Angular 2: bound events are triggered during component initialization now; before
      now they started to trigger after a component got to ngOnInit lifecycle hook.

=========================================================================================
Build Number 5.20161.161              Build Date: 06/12/2016
=========================================================================================

* Bug fixes
    - Fixed memory leak in Angular 1/Angular 2 FlexGrid cell templates.
    - Script error occurs when paste some formula cells from clipboard. (TFS 192540)
    - 'Invalid Date' error shows in date cells in ExcelBook sample. (TFS 192539)
    - Script errors occur and FlexSheet UI is distorted when insert chart and navigate to 
      other sheets. (TFS 192642)
    - Series disappear from chart when deleting values from cell range of inserted chart.
      (TFS 191087)

=========================================================================================
Build Number 5.20161.159              Build Date: 06/08/2016
=========================================================================================

* Improvements
    - Improved FlexGrid.stickyHeaders property to work within nested scrollable container
      elements, improved StickyHeaders sample to demonstrate this and how to add sticky
      toolbars to the grid:
      http://demos.wijmo.com/5/SampleExplorer/SampleExplorer/Sample/StickyHeaders
    - Added FlexGrid.updatingLayout and updatedLayout events.
    - Added a FlexGrid.updatingView event to match FlexGrid.updatedView.
    - Added wijmo.grid.multirow extension module. Contains the MultiRow control that extends 
      conventional grid layouts by using multiple rows to represent each data item. See
      sample here:
      http://demos.wijmo.com/5/SampleExplorer/SampleExplorer/Sample/MultiRowIntro
    - Added a Gauge.getText callback property used to customize text values shown on gauges.
      This new property is shown in the GaugeIntro sample:
      http://demos.wijmo.com/5/SampleExplorer/SampleExplorer/Sample/GaugeIntro
    - Addled a ValueFilter.sortValues property that allows users to specify that they don't 
      want the values to be sorted when displayed in the filter editor.
    - Improved focus handling to work with controls hosted in "shadowRoot" elements
      (see the wijmo.getActiveElement() method).
    - Added style property for WorkSheet class, user is able to set the style for all the
      cells in the Worksheet for exporting.
    - Added PivotGrid.showRowFieldSort property. See this thread for details:
      http://wijmo.com/topic/pivotgrid-rowfield-columns-do-not-respect-allowsorting-or-showsort/#post-75360
    - Added MultiSelect.checkedItems property to Angular directives.
    - Added Popup.dialogResult and Popup.dialogResultEnter properties to make it easier 
      to create and handle modal dialogs.

* Bug fixes
    - 'Freeze' icon in toolbar did not refresh when freezing is applied in FlexSheet in
      ExcelBook Ng2 sample. (TFS 152308)
    - 'remove' and 'removeAt' methods of SheetCollection class did not work as expected.
      (TFS 152477)
    - Excel-like drag and drop was not working correctly for checkbox column when loads 
      workbook into the FlexSheet. (TFS 152292)
    - When select chart on the sheet, cell range selection was lost. (TFS 152995)
    - FlexSheet control loaded date formats incorrectly if system's time zone contains
      daylight time. (TFS 153785)
    - Dates falling in Daylight savings time zone was exported incorrectly. (TFS 147908)
    - Undo/Redo does not work correctly when input 2 or more formulas into the sheet.
      (TFS 189042)
    - Column-header and row-header of previous selected cell was highlight even when 
      current selection is changed. (TFS 189050)
    - Context-menu of the browser did not pop up in editing cell. (TFS 189340)
    - When undo the current cell in editing mode, original value was not restored in 
      editing cell. (TFS 189582)
    - 'Min, Max and Average' formulas did not work correctly in Date column. (TFS 189044)
    - 'round' formula did not work correctly. (TFS 153963)
    - Columns could be selected by clicking column headers. (TFS 190326)
    - Groups did not collapse/expand and columns are were not resizeable after freezing
      the pane. (TFS 190311)
    - Script errors occur when 'wijmo.grid.sheet.filter.min.js' is not included as script
      reference in Benchmark sample. (TFS 190312)
    - Multiple console errors are observed and empty sheet is displayed in Ng2 ExcelBook,
      FlexSheetIntro and FlexSheetExplorer sample. (TFS 190260)
    - Drop marker and tooltip do not show while dragging a row. (TFS 190542)
    - Unlike MS Excel, hidden rows and columns render in the inserted chart. (TFS 190562)
    - 'UndoStack' is not working correctly after import an Excel file into the FlexSheet.
      (TFS 190842)
    - 'previous' button for sheet navigation does not work if 'visible' property of a 
      sheet is set as 'false'. (TFS 190917)
    - Empty chart is shown on the sheet after resize the browser window. (TFS 190959)
    - Status bar shows date time incorrectly when select an empty cell. (TFS 191072)
    - Series disappear from chart when deleting values from cell range of inserted chart.
      (TFS 191087)
    - Formula not getting updated when copy paste the fomula. (TFS 190785)
    - 'Cut' operation is not able to do in the FlexSheet like MS Excel. (TFS 191694)

* Breaking changes
    - The CollectionView.moveCurrentToPrevious method used to allow moving the cursor to
      position -1. Now it stops moving when the cursor reaches the first item (position zero).
      This was done for two reasons:
      1) To make the method more convenient to use in typical first/prev/next/last VCR-style 
         navigation buttons (the 'prev' button can now be linked to moveCurrentToPrevious 
         without any additional tests), and
      2) To improve consistency with the moveCurrentToNext method, which stopped at the last 
         item in the collection.

=========================================================================================
Build Number 5.20161.154              Build Date: 05/19/2016
=========================================================================================

* Improvements
    - The Angular 2 samples missing in build 153 have been ported to RC.1

=========================================================================================
Build Number 5.20161.153              Build Date: 05/17/2016
=========================================================================================

* Improvements
    - Wijmo for Angular 2 components adapted to Angular 2 RC.1 

=========================================================================================
Build Number 5.20161.151              Build Date: 05/06/2016
=========================================================================================

* Bug fixes
    - 'preserveSelectedState' property is not working correctly in the FlexSheet. (TFS 152476)
    - Moving charts make resizing the charts when 2 or more charts are placed on the 
      sheet. (TFS 153047)

=========================================================================================
Build Number 5.20161.150              Build Date: 05/05/2016
=========================================================================================

* Bug fixes
    - 'Freeze' icon in toolbar did not refresh when freezing is applied in FlexSheet in
      ExcelBook Ng2 sample. (TFS 152308)
    - Setting data format apply the whole sheet in 'Format Cells' sample on clicking 
      top-left cell in FlexSheetIntro Ng2 sample and FlexSheetExplorer Ng2 sample.
      (TFS 152947)
    - Date series did not render correctly when select date column and inserting any 
      chart type. (TFS 152996)
    - Cell contents could not be deleted on pressing 'Delete' key while in editing 
      mode. (TFS 153246)
    - Error when clicking Previous or Next button on FlexSheet tab holder after 
      clearing all sheets. (152466)
    - 'remove' and 'removeAt' methods of SheetCollection class did not work as expected.
      (TFS 152477)
    - Freezing is not working correctly after navigating to other sheet. (TFS 152188)

=========================================================================================
Build Number 5.20161.149              Build Date: 05/04/2016
=========================================================================================

* Improvements
    - Added a wijmo.olap.PivotEngine.totalsBeforeData property that determines 
      whether totals and grand totals should be displayed before or after the
      data they summarize.

* Bug fixes
    - FlexSheet undo/redo was not working correctly when copying and pasting
      multiple rows. (TFS 152820)
    - Empty chart appeared when selecting all cells and inserting a chart for the
      first time. (TFS 152822)
    - Inserted charts were still shown after creating a new FlexSheet and loading 
      an Excel file. (TFS 152914)
    - PivotGrid did not always show collapse/expand icons correctly.

=========================================================================================
Build Number 5.20161.146              Build Date: 04/28/2016
=========================================================================================

* Bug fixes
    - Fixed FlexGridXlsxConverter issue console error occurs and excel file cannot be 
      saved. (TFS 152716)
    - Fixed issue Console error "Object.keys: argument is not an Object"  is observed when 
      inserting chart without selecting cell range. (TFS 152721)
    - Fixed issue Cell data also get deleted when remove Chart on the sheet by pressing 
      Delete key. (TFS 152731)
    - Fixed FlexSheet issue when 'selectionMode' is set to 'ListBox', non-continuous 
      columns cannot be selected using 'Ctrl + Click'. (TFS 152493)
    - Fixed issue that prevented the PivotField from handing deep bindings correctly.

=========================================================================================
Build Number 5.20161.144              Build Date: 04/26/2016
=========================================================================================

* Improvements
    - Added an ODataCollectionView.load method to re-fetch the data from the server. (TFS 139722)
    - Added CollectionView.sourceCollectionChanging and CollectionView.sourceCollectionChanged events.
    - Added support for deleting the content of multiple cells on the FlexSheet. (TFS 139728)
    - Added support for exporting borders in xlsx export. (TFS 149656, 147911)
    - Optimized horizontal scrolling on the FlexGrid (especially noticeable in IE, 
      with large numbers of columns).
    - Added Chart support in FlexSheet (as a part of ExcelBook sample). 
    - Wijmo Angular 2 components adapted to Beta.15. 
    - Added a 'wj-header-alt' class to alternating cell headers (to avoid interference 
      with existing CSS using 'wj-alt' class, which is applied only to scrollable cells).

* Bug fixes
    - Fixed issue with partially visible checkbox cells in the FlexGrid.
    - Fixed FlexGridXlsxConverter issue the number format without decimals setting such as 
      'c', 'n' and etc. was not converted to expected xlsx number format. (TFS 149637)
    - Fixed FlexSheet issue the undo/redo action works incorrectly for paste operation.
    - Fixed FlexSheet issue multiple issues are observed on setting 'selectionMode' 
      property. (TFS 152493)
    - Fixed issue that prevented PivotFields from handling deep bindings 
      (e.g. binding = 'person.firstName')

=========================================================================================
Build Number 5.20161.143              Build Date: 04/07/2016
=========================================================================================

* Improvements
    - Improved keyboard/focus handling in Popup control (TFS 148651)
    - Improved the FlexGridFilter value filters to behave more like Excel (TFS 133354)
      The values shown for a column include only items that are not excluded by other filters. 
      For example, if you filter a list by 'name' and that results in two items being shown, 
      other field filters will only show the values of those two items.
    - Added new settings to AllowResizing enum to allow resizing rows and columns by
      dragging the edges of scrollable (non-header) cells. This is especially useful when
      headers are hidden (see headersVisibility). The updated settings are
        export enum AllowResizing {
            None
            Columns,
            Rows,
            Both,
            ColumnsAllCells, // resize columns by dragging cell edges
            RowsAllCells,	 // resize rows by dragging cell edges
            BothAllCells	 // resize rows and columns by dragging cell edges
        }
    - Improved the adding/removing/changing sheet operations of sheets collection for 
      FlexSheet control.

* Bug fixes
    - InputMask didn't always fire the valueChanged event.
    - Fixed FlexSheet issue the edited value is not able to apply the date format. 
      (TFS 145403)
    - Fixed FlexSheet issue the dragging marker shows outside the FlexSheet border when 
      dragging the mouse to outside control border. (TFS 146133)
    - Fixed FlexSheet issue Setting 'selectionRanges' property of Sheet is not working 
      as expected. (TFS 144511)
    - Fixed FlexSheet issue 'Insert/Delete Rows/Columns' context menu is not working on 
      iPad. (TFS 147163)
    - Fixed FlexSheet issue JavaScript error is observed when filter is applied after 
      column has been merged. (TFS 147123)
    - Fixed PivotChart issue that error occurs on hovering mouse over PivotChart when there  
      is 'Date' field in 'Values' list. (TFS 147209)
    - Fixed FlexSheet issue 'Insert/Delete' context menu pop up in data-bound sheet in
      iPad. (TFS 143242)
    - The FlexGrid did not honor the 'cancel' property in the resizingRow/Column events 
      (TFS 144204).
    - Fixed FlexSheet issue 'formatItem' doesn't work in FlexSheet.
    - Fixed FlexSheet issue Error occurs when scroll and open a sheet in 'Formulas' page
      in FlexSheetExplorer sample. (TFS 148074)
    - Fixed FlexSheet issue Filter dialog is still shown when navigating to other sheet.
      (TFS 147830)
    - Fixed FlexSheet issue 'gotFocus' event does not fire when click sheet tabs. 
      (TFS 146789)
    - Fixed FlexSheet issue Error occurs when pressing 'Ctrl+Z' to 'Undo' insert/delete 
      actions after deleted all cells and inserted a cell. (TFS 149347)
    - Fixed FlexGridXlsxConverter issue Incorrect values and incorrect date format are 
      exported to XLSX document. (TFS 149467)

* Breaking changes
    - wijmo.grid.sheet.Sheet class
        -- Remove setter for the 'selectionRanges' property.

=========================================================================================
Build Number 5.20161.138              Build Date: 03/10/2016
=========================================================================================

* Improvements
    - Added wijmo.angular2.* modules (Beta version), that allow to use Wijmo 
      controls in Angular 2 applications markup.
    - Added a wijmo.chart.animation module with the ChartAnimation main class that
      provides animations for the FlexChart, FlexPie and FinancialChart controls.
      The FlexChartAnimation sample demonstrates module's features.
    - Added ChartGestures to the wijmo.chart.interaction module. The class adds 
      touch zoom and panning functionality to the FlexChart control.
      The FlexChartZoom sample demonstrates usage of the class. 
    - Added FlexChartBase.exportToImage method that allows exporting charts to 
      PNG, JPEG, and SVG formats.
    - Added Axis.labelPadding property that controls padding of axis labels.
    - Added a wijmo.olap module that provides Excel-like pivot tables and charts
      to Wijmo.
    - Added a wijmo.pdf module, with the PdfDocument main class that provides client
      side functionality for creating files in PDF format. The module is based on a 
      modified version of the PDFKit library (http://pdfkit.org/) with a footprint
      minified up to 375Kb.
    - Added wijmo.grid.pdf module which is an extension of the wijmo.pdf and
      wijmo.grid modules and provides functionality for exporting FlexGrid to
      PDF format.
    - Added a PrintDocument class to the wijmo module. This class allows you to create
      documents for printing, which in modern browsers includes the option to export
      to PDF.
    - Modified FlexGridFilter module to clear value filters when all possible values 
      are selected.
    - Added a FlexGrid.preserveSelectedState property to control whether the grid
      should preserve the selected state of rows when the data is refreshed.
    - Added a FlexGrid.preserveOutlineState property to control whether the grid
      should preserve the collapsed/expanded state of group rows when the data is 
      refreshed.
    - Added a Tooltip.showAtMouse property that causes the tooltip position to be
      computed based on the mouse position rather than on the target element.
    - Made FlexGrid "stickyHeaders" visible to the mouse, so users can interact
      with columns (sort/move/resize/filter) while in sticky mode.
    - Added FlexSheetExplorer sample.

* Bug fixes
    - Fixed FlexSheet issue Script error occurs when a column is merged and filter the 
      FlexSheet by a column. (TFS 143544)
    - Fixed FlexSheet issue editing cell does not exit on pressing 'Esc' key after 
      scrolled through formula menu using mouse. (TFS 142370) 
    - Fixed FlexSheet issue the existed sheet disorted  if the new sheet was added before
      current selected sheet. (TFS 143291)
    - Fixed FlexSheet issue Script error occurs when switch unbound sheet to bound sheet,
      if the range of the selection in the unbound sheet is out of the range of the bound
      sheet. (TFS 142436)
    - Fixed FlexSheet issue Formula value and formula cells number are not updated when 
      editing the data or moving the columns which include in formula range. (TFS 143764)
    - Fixed FlexSheet issue multiple selection doesn't work after the CellFactory of 
      FlexGrid being updated.
    - Fixed FlexSheetExplorer sample Unlike 'Merge' button , 'Freeze' button does not 
      refresh when a new sheet is added. (TFS 142587)
    - Fixed FlexSheetExplorer sample Reference cell is incorrect in 'Year', 'Month' and
      'Day' formula cells. (TFS 142784)
    - Fixed FlexSheet Explorer sample ColorPicker is not displayed properly when opening
      'Fill Color' and 'Fore Color' in iOS device or Android device. (TFS 143243)
    - Fixed ODataCollectionView.totalItemCount to account for paging on the client.
    - Fixed FlexSheet issue Console error is observed on clicking 'Show Filter' button 
      when a new sheet is added. (TFS 145135)
    - Fixed FlexSheet issue Error is observed when resizing column/row header in the empty
      Sheet. (TFS 145154)
    - Fixed FlexSheet issue Setting 'ActiveWorksheet' property of Workbook does not have 
      effect in FlexSheet. (TFS 144381)
    - Fixed FlexSheet issue Columns and rows are not able to drag and drop when Workbook 
      is loaded into the flexSheet. (TFS 144546)
    - Fixed FlexSheet issue Insert/Delete context menu does not pop up when FlexSheet is 
      placed inside Popup. (TFS 144667)
    - Fixed FlexSheet issue 'Visible' property of Sheet is not working properly. 
      (TFS 144802)
    - Fixed FlexSheet issue 'Loaded' event is not working as expected. (TFS 144490)
    - Fixed FlexGridXlsxConverter issue FlexGrid exporting column binding field rather 
      than the column labels to Excel. (TFS 145142)
    - Fixed FlexSheet issue the edited value is not able to apply the number format.
      (TFS 145403)
    - Fixed FlexSheet issue Drag and drop marker do not show when the FlexSheet is placed 
      inside Popup. (TFS 145900)
    - Fixed FlexSheet issue 'Insert/Delete' context-menu does not automatically close 
      when navigate to other page in iPad. (TFS 145753)
    - Fixed FlexSheet issue Dragging markers show in empty web page on dragging row or 
      column. (TFS 146133)
    - Fixed FlexSheet issue Drag and drop markers do not show properly when the direction 
      of the FlexSheet is 'right to left'. (TFS 145889)
    - Wijmo AngularJS directives may trigger the 'initialized' event multiple times in case
      where its child directives generated by ng-repeat/ng-if directives.
    - Fixed FlexSheet issue 'Insert/Delete Rows/Columns' context menu is not working on 
      iPad. (TFS 147163)
    - Fixed FlexSheet issue JavaScript error is observed when filter is applied after 
      column has been merged. (TFS 147123)
    - Fixed FlexSheet issue 'Insert/Delete Rows/Columns' context menu is not working on 
      iPad. (TFS 147163)
    - Fixed FlexSheet issue 'Insert/Delete' context menu pop up in data-bound sheet in
      iPad. (TFS 143242)

* Breaking changes
    - wijmo.grid.sheet.FlexSheet class
        -- Remove the 'override' parameter for the 'addCustomFunction' method.

=========================================================================================
Build Number 5.20153.117              Build Date: 01/27/2016  
=========================================================================================

* Bug fixes
    - Fixed FlexSheet issue newly added sheet is distorted when an unbound sheet is added
      using 'addUnboundSheet' function. (TFS 143291)
    - Fixed FlexSheet issue 'Insert/Delete' context menu pop up in data-bound sheet in
      iPad. (TFS 143242)
    - Fixed FlexSheet issue 'Insert/Delete' context menu displays at incorrect position
      in iPad. (TFS 143246)
    - Fixed FlexSheet issue Group header rows are not able to drag and drop. (TFS 143130)
    - Fixed FlexSheet issue sizing icon does not show properly at top-left cell in unbound
      Sheet. (TFS 143418)
    - Fixed FlexSheet issue first cell enters into edit mode when clicking top-left cell.
      (TFS 143426)
    - Fixed FlexSheet issue javascript error is observe after entering edit mode and 
      loading an excel file in IE. (TFS 143504)

=========================================================================================
Build Number 5.20153.116              Build Date: 01/25/2016  
=========================================================================================

* Improvements
    - Added a wijmo.input.DropDown.dropDownCssClass property to make it easier to style
      the drop-down elements of the controls (this applies to all controls that extend
      DropDown, including ComboBox, MultiSelect, InputDate, InputTime, etc).
    - Added a wijmo.grid.Column.dropDownCssClass property to make it easier to style
      the drop-down list used to edit cells in columns that have dataMaps.
    - Added a wijmo.collections.CollectionView.useStableSort property that causes the
      CollectionView class to use a stable sort algorithm which is 30 to 50% slower
      than the native sort but maintains the relative order of records with equal keys.

* Bug fixes
    - Fixed FlexSheet issue Formula menu does not open when entering '=' in Firefox.
      (TFS 142491)
    - Fixed FlexSheet issue Formula menu is overlapping over current cell in IE. 
      (TFS 142495)
    - Fixed FlexSheet issue Formula menu does not close on pressing 'Esc' key after 
      scrolled through formula menu using mouse. (TFS 142370)
    - Fixed FlexSheet issue Vertical scrollbar scroll along with mouse after dragging and
      dropping a row in FlexSheet. (TFS 142369)
    - Fixed FlexSheet issue Some incorrect behaviors are occurred when cells are marge by
      'mergeRange' method. (TFS 142367)
    - Fixed FlexSheet issue Javascript error is observe after selecting a column and
      deleting a row when setting 'allowMerging' property to 'all' in bound sheet.
      (TFS 142348)
    - Fixed FlexSheet issue The drag drop row marker display inconsistency when IE or 
      FireFox is resized. (TFS 142679)
    - Fixed FlexSheet issue Javascript error is shown when clicking the top-left cell 
      after adding row headers more than the columns of the sheet. (TFS 142581) 
    - Fixed FlexSheet issue Observed incorrect freezing behavior when scroll down the 
      FlexSheet and freeze at a lower position. (TFS 143006)
    - Fixed FlexSheet issue Observed performance problem when scrolling the FlexSheet 
      after loaded an Excel file which contains over 2000 data rows. (TFS 142887)
    - Fixed FlexSheet Sheets navigation is not working properly when there is multiple 
      sheets in the FlexSheet. (TFS 142788)
    - Fixed FlexSheet issue Undo process is not working after drag and drop a column.
      (TFS 142888)
    - Fixed FlexSheet issue Cells are distorted on adding a new column after clear all 
      columns in unbound sheet. (TFS 140344)

=========================================================================================
Build Number 5.20153.112              Build Date: 01/16/2016
=========================================================================================

* Improvements
    - Added a new InputDateTime control to enter/edit date and time values using a
      single control (as opposed to using an InputDate and an InputTime).
    - Added a new FlexGrid.imeEnbled property to support IME modes while the grid
      is not in edit mode. This property benefits sites and applications in Japanese,
      Chinese, Korean and other languages that require IME support.
    - Improved FlexGrid.focus() implementation to prevent the browser from scrolling 
      the grid's hostElement into view when the grid gets the focus.
    - Improved allowAddNew to work better with childItemsPath.
    - Improved IE9 polyfill to support drag/drop in modal dialogs (TFS 140812)
    - Added Angular 2 Explorer sample with components for core Wijmo controls. The 
      sample uses Beta.1 version of Angular 2.
    - wijmo.xlsx
        -- Added support for several new functions:
            Column
            Columns
            COUNTA
            COUNTBLANK
            COUNTIF
            COUNTIFS
            DATE
            DATEDIF
            DCOUNT
            HLOOKUP
            HOUR
            INDEX
            MOD
            RANK
            RATE
            ROUNDDOWN
            ROUNDUP
            ROW
            ROWS
            SUBTOTAL
            SUMIF
            SUMIFS
            TIME
            TODAY 
        -- Added support for importing shared formulas.
        -- Improved performance.
    - wijmo.grid.sheet 
        -- Added support for user-provided custom functions, see the 
           FlexSheet.addCustomFunction method.
        -- Added FlexSheet.unknownFunction event that allows to process
           non-supported functions found in cell expressions.
        -- Added Sheet.itemsSource property that allows to change the items
           source for data bound sheets.
    - Added a wijmo.input.DropDown.dropDownCssClass property to make it easier to style
      the drop-down elements of the controls (this applies to all controls that extend
      DropDown, including ComboBox, MultiSelect, InputDate, InputTime, etc).
    - Added a wijmo.grid.Column.dropDownCssClass property to make it easier to style
      the drop-down list used to edit cells in columns that have dataMaps.
    - Added a wijmo.collections.CollectionView.useStableSort property that causes the
      CollectionView class to use a stable sort algorithm which is 30 to 50% slower
      than the native sort but maintains the relative order of records with equal keys.

* Breaking changes
    - The wijmo.xlsx.XlsxConverter class is deprecated. Use the wijmo.xlsx.Workbook
      class instead. XlsxConverter is still supported for compatibility and will be
      eliminated in the future releases.
    - wijmo.grid.xlsx.FlexGridXlsxConverter class:
        -- the 'export', 'toWorkbookOM', 'import' and 'fromWorkbookOM' methods are deprecated.
           Use the 'save' and 'load' methods instead. The old methods are still supported for 
           compatibility and will be eliminated in the future releases.
    - wijmo.grid.sheet.FlexSheet class:
        -- saveToWorkbookOM and loadFromWorkbookOM methods are deprecated. 
           Use the 'save' and 'load' methods instead. The old methods are still supported for 
           compatibility and will be eliminated in the future releases.
    - CellRangeEventArgs class: removed property "cellRange", which was deprecated 
      in build 105 and replaced by "range".
    - HitTestInfo class: removed property "gridPanel", which was deprecated 
      in build 105 and replaced by "panel".

* Bug fixes
    - Fixed grid to to include all items and sub-items in aggregates (TFS 139570,
      partially fixed earlier in build 5.20143.35)

=========================================================================================
Build Number 5.20153.109              Build Date: 12/10/2015
=========================================================================================

* Improvements
    - Improved CollectionView.trackChanges to allow tracking of changes made to items
      that are not the current edit item. The most common scenario is pasting blocks
      of data into a FlexGrid.
    - Improved FlexGrid.childItemsPath property to accept arrays of strings in case
      items at different levels use different property names for their child items.

=========================================================================================
Build Number 5.20153.108              Build Date: 12/06/2015
=========================================================================================

* Improvements
    - Changed the default value of the InputTime.step property to 15 (which seems
      to be the most common/useful setting). This causes the control to display
      the drop-down button by default; to remove the button, set the step property
      to null.
    - Added support for opening FlexGrid.dataMap dropdowns using the keyboard
      (F4, alt+up/down, like WinForms and WPF/Excel) (TFS 124408)
    - Improved the Control.dispose method to remove all Wijmo event listeners from the control
      being disposed (dispose also removes all HTML event listeners added with the 
      Control.addEventListener method).
    - Added a DropDown.autoExpandSelection property that determines whether input 
      controls should automatically select whole words/numbers when clicked.
      This applies to all controls that derive from DropDown, and makes it easier
      to edit dates, times, colors, etc.
    - Added a ComboBox.headerPath property that allows decoupling the values shown in
      the combo's input element from the values shown in the drop-down list.
    - Improved Globalize to support formatting of fiscal years and quarters with the 
      following format specifiers:
        - 'EEEE': government fiscal year
        - 'eeee': corporations fiscal year
        - 'U': government fiscal quarter
        - 'u': corporations fiscal quarter
      The conversion from calendar to fiscal date is culture-dependent. If you are 
      not using the appropriate culture file (and don't want to), then you can 
      specify the conversion factor by setting the 
      wijmo.culture.Globalize.calendar.fiscalYearOffset variable to an array
      containing two integers that represent the offset (in months) of the start of 
      the fiscal year for government and for the private sector.
      For example, the Japanese culture uses a three month offset for the government's
      fiscal year and no offset for the private sector:
          wijmo.culture.Globalize.calendar.fiscalYearOffsets = [3, 0];
    - Added five new glyphs to wijmo.css:
        wj-glyph-step-forward
        wj-glyph-step-backward
        wj-glyph-file
        wj-glyph-calendar
        wj-glyph-clock
    - Added automatic label rotation for FlexChart category x-axis. The labels are 
      rotated to avoid overlapping if axis.labelAngle is not specified.	
    - Used IntelliSpell to spell-check all the documentation.
    - The FlexGridXlsxConverter class now supports row headers export. The behavior
      is controlled by the IFlexGridXlsxExportOptions.includeRowHeaders property.

* Breaking changes
    - wijmo.grid.xlsx module, the IFlexGridXlsxExportOptions interface:
        - 'needGetCellStyle' property has been renamed to 'includeCellStyles'. 
        - 'includeColumnHeader' property has been renamed to 'includeColumnHeaders' (ending 's'). 
      The old property names have been deprecated and will be removed in future builds.

=========================================================================================
Build Number 5.20153.105              Build Date: 11/17/2015
=========================================================================================

* Improvements
    - Improved InputMask handling of delete key with masks that contain numbers in the
      template (e.g. "99-55-9999", TFS 136087).
    - Add minScale/maxScale to RangeSelector extension for controlling the valid range.
    - Added FlexGrid.selectedRows and selectedItems properties. Both can be used to get
      a list with the currently selected rows or their associated data items. When the
      selectionMode property is set to ListBox, they can also be used to set the selected 
      rows or data items.
    - Refactored wijmo.grid.filter.FlexGrid filter by removing the OData-specific 
      getODataFilterDefinition method and replacing it with a call to the collection
      view's updateFilterDefinition method; which if present updates the filter definition
      used on the server-side. This refactoring allows other CollectionView implementations
      (such as BreezeCollectionView) to support server-side filtering.
    - Improved BreezeCollectionView sample to show server-side filtering (TFS 129832).
    - Added support for Japanese characters (IME, Katakana, Hiragana) in InputMask control.
    - Added a FlexGrid.showAlternatingRows property to allow disabling alternate row
      styling without changing any CSS rules.
    - Added a FlexGrid.updatedView event that fires when the grid finishes creating/updating 
      the cell elements for the current view (e.g. after binding, refreshing, resizing, 
      scrolling, etc.)

* Bug fixes
    - InputDate control did not preserve the time part of the value being edited.

=========================================================================================
Build Number 5.20153.102                Build Date: 10/29/2015   
=========================================================================================

* Improvements
    - Added wijmo.xlsx module that provides client-side functionality for exporting and 
      importing to/from Excel xlsx file.
      The ExcelImportExport sample is updated with examples demonstrating its usage.
    - Added wijmo.grid.xlsx module, which is an extension to the wijmo.xlsx module,
      that provides client-side functionality for exporting and 
      importing FlexGrid to/from Excel xlsx file.
      The ExcelImportExport sample is updated to use this module.
    - Added wijmo.grid.sheet module, which is an extension to the wijmo.grid
      and wijmo.grid.xlsx modules. It implements the FlexSheet control
      that provides an Excel-like functionality.
      The ExcelBook sample is updated to use this module.
    - Added AngularJS PdfExport sample that implements client-side export
      of a FlexGrid control to PDF format.
    - Added AngularJS FlexChartAnimation sample. The sample shows chart animation
      when loading and updating chart data.
    - Added AngularJS FlexChartZoom sample. The sample demonstrates chart interaction
      using touch gestures or mouse.
    - Added PureJS AggregateSeries sample for FlexChart. The sample shows data aggregation
      based on selected data range.
    - New RangeSelector.seamless property allows seamless transition between selector handles.
    - New appearance of RangeSelector handles simplifies dragging at smaller ranges.
    - New FinancialChart overlays: Bollinger Bands & Moving Average Envelopes.
    - New FinancialChart indicators: Average True Range, Relative Strength Index,
      Commodity Channel Index, Williams %R, MACD/MACD Histogram, Stochastic Oscillator.
    - New Fibonacci Extensions for FinancialChart: Fans, Arcs, Time zones.
    - Improved wijmo.grid.filter.FlexGridFilter to allow filtering with merged headers.
    - Improved auto-generated column headers.
      (we now capitalize first letter, break up camel-case binding strings, so the header
      for a column bound to the 'productName' property becomes 'Product Name' be default).
    - Optimized wijmo.closest method to use 'matches' method instead of 'querySelectorAll'.
    - Improved InputNumber control behavior on mobile devices.
    - Added a FlexGrid.stickyHeaders property that keeps column header cells in view
      even when the top of the grid scrolls off view.
    - Improved CollectionView change tracking to ignore items that are added and 
      subsequently removed in the same session.
    - Improved Globalize to support formatting of date quarters with the 'q' or 'Q'
      format specifiers (e.g. format(someDate, 'yyyy "Q"q') => '2014 Q4').

* Bug fixes
    - Fixed issue with legend hit test for pie chart(TFS 134321).
    - Fixed problem with focus after toggling legend items in Edge(TFS 132748).
    - Fixed problem with legend height when series names are long(TFS 132957).
    - Fixed issue with incorrect chart layout for category axis with long labels. 
    - Fixed issue with clipped y-axis labels(TFS 135127).
    - Fixed issue with minimum value should not allowed to set over maximum value in range selector(TFS 135758).
    - Improved InputNumber to deal with some mobile browser idiosyncrasies (TFS 135585)
    - Improved Globalize.parseDate to better handle Japanese formats (TFS 136057)


=========================================================================================
Build Number 5.20152.93              Build Date: 10/14/2015
=========================================================================================

* Bug fixes
    - Destroying controls interfered with touch support in some scenarios.
    - Improved behavior of InputNumber on Windows Phone and a few other mobile devices.
    - Disabled HTML input auto-complete in InputNumber and DropDown controls 
      (important for mobile browsers)
    - FlexGrid.selectionChanging event could not be canceled properly in ListBox 
      selection mode.

=========================================================================================
Build Number 5.20152.90              Build Date: 09/28/2015
=========================================================================================

* Improvements
    - Added FlexGrid.pastingCell/pastedCell events. These events fire while the grid 
      is pasting data into individual cells. Previously, the grid would fire editing
      events in these situations, but that led to some ambiguities that affected the
      implementation of custom editors.

=========================================================================================
Build Number 5.20152.87              Build Date: 09/24/2015
=========================================================================================

* Improvements
    - Added support for hexadecimal formatting/parsing; use format 'xn' or 'Xn' (TFS 131809)
    - Made AutoComplete control honor the "isEditable" property (inherited from ComboBox, TFS 81936)

* Bug fixes
    - FlexGrid.hitTest method did not set the edgeTop and edgeLeft properties correctly
      on the returned HitTestInfo object.
    - Fixed problem with RowDetails in grids with frozen columns (TFS 131863).
    - Fixed problem with incorrect column width when series has auxiliary axis (TFS 131680). 
    - Fixed problem with major/minor units for time axis (TFS 131682).
    - Fixed JavaScript error in StockChart sample that may appear when moving marker (TFS 131856).
    - Updated MaskProvider to work with browsers that don't fire the keypress event.
    - Fixed chart rendering issue that may cause exception in Firefox under several conditions.

=========================================================================================
Build Number 5.20152.86              Build Date: 09/20/2015
=========================================================================================

* Improvements
    - Added a wijmo.grid.CellFactory.disposeCell method to allow better resource cleanup
      when using custom cell factories.
* Bug fixes
    - Globalize.parseDate failed on some locales (TFS 131320)
    - Fixed problem with incorrect position of selected pie slice label under several conditions (TFS 129756). 
    - Fixed issue with incorrect column widths after adding line series (TFS 131153).
    - Date values now correctly displayed on auxiliary axes (TFS 131294).
    - Fixed exception when using auxiliary axes with stacked bar chart (TFS 131295).
    - Fixed problem with minor ticks/gridlines for category axis (TFS 131297).
    - Fixed problem with hit testing for overlapped series (TFS 131330).
    - Could not cancel FlexGrid.startEditing event on checkbox cells.

=========================================================================================
Build Number 5.20152.85              Build Date: 09/13/2015
=========================================================================================

* Improvements
    - Improved Angular FlexGrid.CellEdit template to use the character that was typed
      when initiating the edits (as the built-in editors do).
    - Added a wijmo.odata.ODataVirtualCollectionView class that loads data on demand.
      See the VirtualData sample for details.
    - ODataCollectionView.filterDefinition property is applied to filter on the server
      even when filterOnServer is set to false. This allows applications to apply 
      server and client-side filtering to the same collection.
    - Made FlexGrid.cellFactory property get/set.
    - Added a wijmo.grid.DataMap.isEditable property to allow users to enter data that
      is not on the DataMap (mapped items become non-exclusive options).
    - wj-menu-item directive now supports AngularJS interpolation expressions and
      directives inside it, and can be used in conjunction with ng-repeat/ng-if
      directives.
    - Data-bound Menu controls now support wj-item-template directive that allows to
      define an arbitrary menu item content.
    - ng-class AngularJS directive is now supported on the wj-flex-grid-column and
      wj-flex-grid-cell-template directives.

* Bug fixes
    - CollectionView.removeAt method issued a notification event with index==-1 instead
      of the original index of the item that was removed.
    - FlexGrid MergeManager did not always behave consistently when merging ranges that
      included both row and column merging (TFS 129001)

* Breaking changes
    - Wijmo directives for AngularJS no longer update controller properties bound to 
      by-ref ('=') properties that logically suppose one-way binding.


=========================================================================================
Build Number 5.20152.84              Build Date: 08/27/2015
=========================================================================================

* Improvements
    - Added a FlexGrid.showMarquee property that determines whether the grid should display
      an Excel-style marquee around the current selection. The marquee may be styled using
      the "wj-marquee" class selector.
    - Added a FlexGrid.showSelectedHeaders property that determines whether the grid should 
      add a "wj-state-multi-selected" class selector to row and/or column header elements;
      these can be used in CSS to highlight header cells that correspond to the current selection.
    - Added a new 'clip' parameter to the FlexGrid.getMergedRange method; if true (the default), 
      the method clips the merged range to the current view range.
      The 'clip' parameter has no effect on grid; it was added to facilitate the development 
      of export utilities, which may need to get merged ranges that are not clipped to the 
      grid's current view range.
    - Added Calendar.itemValidator and InputDate.itemValidator properties to enable preventing
      certain days from being selected.
    - Added a Calendar.formatItem event to complement the Calendar.itemFormatter property.
    - LinearGauge now accounts for thumbSize when dimensioning the gauge's face.

* Bug fixes
    - Improved touch support in editable Gauges.
    - Fixed problem with chart type initialization in constructor parameter(TFS 125747).
    - Pie chart labels displayed correctly when it's position = 'Outside'(TFS 125423).
    - Chart does not change color's alpha if it was specified as rgba in palette (TFS 119543).

* Breaking changes

    - We made a small change to the logic that assigns classes to FlexGrid cells. Before, we 
      removed the wj-group class from selected cells. That is no longer the case. There are 
      two reasons for this change:

      1) Correctness. Group cells remain group cells even when they are selected. Keeping the
         wj-group class allows you to use CSS to style grouped and selected cells independently.
      2) Performance. The new code is (very slightly) more efficient.

      This change could break your custom FlexGrid CSS. If you have CSS rules that affect group 
      colors they should be modified to exclude selected cells. In other words, if you had a 
      rule like this:

        .wj-group {
            background: green;
        }

      You should change it to this:

        .wj-group:not(.wj-state-selected):not(.wj-state-multi-selected) {
            background: green;
        }
  

=========================================================================================
Build Number 5.20152.76              Build Date: 08/13/2015
=========================================================================================

* Improvements
    - Added a new 'wj-state-focused' class to controls that contains the focus. This 
      class is toggled automatically to reflect the control's focus state and can be 
      used in CSS selectors to add focus-related styles to parts of focused controls,
      such as gauge cursors, chart series, and grid ranges.
    - Added Angular attributes for chart series axisX and axisY (TFS 122055).
    - Added wijmo.input.DropDown.isDroppedDownChanging event to allow for customization
      of the drop-down before it is shown.
    - Added wijmo.grid.filter.ValueFiler.uniqueValues property to specify the list of values 
      to be shown on the list, which is more efficient than building the list from the data
      and works on collections that are filtered on the server.
    - Improved features and performance of Globalize.formatDate and parseDate methods.
    - Added scaling specifiers to Globalization.formatNumber and parseFloat. For example,
      'n0,' divides the value by one thousand, 'n0,,' by one million, and 'n0,,,' by one 
      billion. The scaling specifiers are especially useful in charts based on large values
      so the axis display scaled values which are easier to read and take up less space.
    - Added a Gauge.thumbSize property that enables displaying a 'thumb' element to show
      the current value at the end of the 'pointer' range. This applies to linear and 
      radial gauges.
    - Added mouse wheel support to editable Gauges.

* Bug fixes
    - Prevented AutoComplete from selecting all the text while the user types.
    - Fixed problem with toggling data series visibility for multiple y-axes(TFS 122051).
    - Fixed error in chart hit test demo(Explorer sample) TFS 124526.
    - Axis ticks displayed correctly with rotated labels(TFS 125399).
    - Axis ticks and grid lines rendered properly with overlapped axis labels(TFS 125273).
    - Chart focus events fire correctly in IE(TFS 124275).
    - Candlestick and HighLowOpenClose chart types now support 'rotated' property(TFS 118721).
    - Fixed problem with series visibility toggle when there are hidden series(TFS 110615). 
    - Fixed problem with major and minor grid lines for category x-axis(TFS 110250).
    - Chart updated correctly after changing axis 'reversed' property(TFS 100492).
    - Added angular attribute for axis 'overlappingLabels' property(TFS 98919). 

=========================================================================================
Build Number 5.20152.72            Build Date: 07/20/2015
=========================================================================================

* Improvements
    - Added support for several new cultures.

* Bug fixes
    - Axis labels rendered correctly when Axis.overlappingLabels=Show(TFS 124732).

=========================================================================================
Build Number 5.20152.71          Build Date: 07/14/2015
=========================================================================================

* Improvements
    - Added wijmo.chart.finance extension module, contains FinancialChart control. The module
      is a part of Wijmo 5 Enterprise edition only.
    - Added wijmo.chart.analytics extension module, containing a set of specialized series 
      classes intended for creating of analytical charts using FlexChart and FinancialChart 
      controls:
        TrendLine (A calculation of simple linear or growth trend that fits different fitType)
        MovingAverage (A calculation by creating a series of averages of different subsets)
        YFunctionSeries (A calculation of y by given function)
        ParametricFunctionSeries (A calculation of x and y by given xFunc and yFunc)
    - Added wijmo.chart.annotation extension module, implements a possibility to add annotations
      of different types to FlexChart and FinancialChart controls:
        AnnotationLayer (A layer that contains a collection of annotations of different types)
        Annotations:
            Circle
            Ellipse
            Image
            Line
            Polygon
            Rectangle
            Square
            Text
    - Added wijmo.chart.finance.analytics module, contains Fibonacci tool.
    - Added support for multiple plot areas in FlexChart and FinancialChart.
    - Improved label generation for time and category axes.
    - Added support of custom data label rendering(DataLabel.rendering event).
    - Added connecting lines for data labels(DataLabel.connectingLine property).
    - Added DataLabel.offset property to specifies offset from date point to the corresponding label.  
    - Added Axis.labelAlign property to control alignment of axis labels.
    - Axis properties min, max, actualMin, actualMax support Date objects for time-based data source.
    - Added property SeriesBase.altStyle to specify alternative style for data series.
    - Added Position.Auto option that allows to automatically set chart legend position
      depending on control's size.
    - Added ExcelBook sample that implements FlexSheet control that provides Excel-like
      functionality. The implementation is based on the FlexGrid control.
    - Added AxisScrollBar sample. The sample demonstrates axis scroll bars that allow to scroll
      through and change scale of displayed data.
    - Added FinancialChartExplorer sample. The sample shows available financial chart types.
    - Added FinancialChartIntro. The sample in an introduction to FinancialChart control.
    - Added FlexChartAnalytics. The sample shows extended chart functionality
      from wijmo.chart.analytics module.
    - Added FlexChartAnnotation. The sample demonstrates annotations created
      with wijmo.chart.annotation module.
    - Added StockChart. The sample shows various features of FinancialChart control. 
    - Added a new wijmo.input.MultiSelect control (allows picking multiple items from a drop-down).
    - Added a new wijmo.input.Popup control (shows arbitrary elements as popups/popovers/dialogs).
    - Added a Menu.owner property for use in shared context menus.
    - Added filterChanging and filterChanged events to the FlexGridFilter class.
    - Improved FlexGridFilter to ignore invalid condition filters such as 
      "contains('')" or "beginswith('')".
    - Optimized ODataCollectionView to skip schema/version query in some situations.
    - Prevent browser from trying to scroll the whole grid into view when it gets focus.
    - Added Control.gotFocus and lostFocus events.
    - Added mouse wheel support to Input controls.

* Bug fixes
    - Fixed problem with RangeSelector when left handle and right handle are overlap with each other (TFS 106637).
    - Fixed incorrect behaviors when scrolling chart axes scrollbars (TFS 121008).
    - Fixed issue with clipped labels for time axis(TFS 121607). 
    - Fixed annotation's tooltip showing error in FlexChartAnnonation sample(TFS 122855).
    - Fixed javascript error when showing 'MovingAverage' series in StockChart sample(TFS 122724).
    - Prevent CollectionView's tracking from adding cancelled new items to the 
      removed items list (TFS 120148).
    - Fixed issue with hit-testing when the grid was placed inside scrollable containers.
    - FlexGrid not showing checkboxes when childItemsPath set (TFS 122709).
    - Fixed issue with dropdowns cannot open again after choosing LineMarkerInteraction to 
      'Drag' in Wijmo 5 Explorer (TFS 122341).
    - Fixed issue that prevented the back-tab key from working correctly in Chrome when
      navigating the Wijmo input controls (TFS 123457).
    - Fixed problem with data labels for chart with multiple axes(TFS 123631). 
    - Fixed problem with data label formatting for bar chart when binding to Date(TFS 113614).
    - Pie chart data labels now support properties connectingLine and offset. Both properties
      have effect only if label's position equals to 'Inside' or 'Outside'(TFS 124236).


=========================================================================================
Build Number 5.20151.63            Build Date: 06/24/2015
=========================================================================================

* Improvements
    - Added InputMask.rawValue property to get/set the value of the control without
      mask literals and prompt characters.

* Bug fixes
    - Fixed problem with RangeSelector when dragging range handle button (TFS 106637).
    - Fixed exceptions in FlexChartGroup sample(TFS 121249,121476).
    - Fixed problem with not drawing FlexGrid header cell templates under some specific 
      conditions.

=========================================================================================
Build Number 5.20151.59          Build Date: 06/16/2015
=========================================================================================

* Improvements
    - Improved FlexGrid numeric editor to right-align and show the full precision
      of values being edited (like MS-Excel).
    - First input element in FlexGrid edit cell template now automatically gains focus 
      after editing has started.

* Bug fixes
    - Could not drop columns on GroupPanels without placeholder text (TFS 120428)
    - Clicking open split buttons fired itemClicked with a null command (TFS 119513)
    - Only series with the default chart type are stacked. Series with custom types 
      are displayed without stacking (TFS 112971).
    - Fixed exception in FlexChartGroup sample(TFS 113648).
    - Fixed problem pie chart label position for selected slice(TFS 116125).
    - Chart repaints correctly after changing Axis.reversed property(TFS 100492).
    - Fixed problem with chart size when both main axes are hidden.

=========================================================================================
Build Number 5.20151.54          Build Date: 06/08/2015
=========================================================================================

* Improvements
    - Added a wijmo.odata module with an ODataCollectionView class that extends the
      CollectionView class to load and update data exposed as OData services.
    - Added a wijmo.httpRequest method to perform Ajax requests without dependencies.
    - Added wijmo.grid.detail extension to add row details to FlexGrid controls
      (see RowDetails sample).
    - Added support for binding to array properties (e.g. 'customer.balance[0]').
    - Prevent browser from trying to scroll the whole grid into view when it gets focus.
    - Added a ValueFilter.maxValues property to limit the number of unique items to 
      display in the value filter list.
    - Added WjValidationError Angular directive to support validation (HTML5 or Angular 
      forms) based on arbitrary Angular expressions.
    - Added WjItemTemplate directive to support ListBox item templates
      with arbitrary HTML markup (including Angular bindings and directives)

* Bug fixes
    - Fixed problem with HighLowOpenClose chart when data source is CollectionView.
    - Fixed problem that kept the FlexGrid editor active when the user clicked the document body.
    - Fixed problem with incorrect positions and size of columns/bars when mixing chart types. 
    - FlexGrid.autoSizeColumns method did not honor lastColumn parameter (TFS 84456)

=========================================================================================
Build Number 5.20151.51          Build Date: 05/13/2015
=========================================================================================

* Improvements
    - Improved scrolling performance in IE

=========================================================================================
Build Number 5.20151.50          Build Date: 05/07/2015
=========================================================================================

* Improvements
    - Improved scrolling performance in IE (found out that border-radius on the host 
      element seriously degraded rendering performance in IE, so now we set it to zero).
    - Added wijmo.setText method to set or clear the content of HTML elements as 
      efficiently as possible.
    - Added FlexGridFilter.filterDefinitions property to serialize filters to/from JSON.
    - Added ListBox.formatItem event (same semantics as FlexGrid.formatItem)
    - Added support for Excel shortcuts: ctrl+A = select all, shift+Enter: select up.

* Bug fixes
    - Added FlexGrid row/column drag support in IE9
    - Column filters were not positioned properly in right-to-left grids (TFS 117022)
    - FlexGrid did not initialize layout when used in an ngDialog in Chrome (TFS 116340)

=========================================================================================
Build Number 5.20151.49          Build Date: 04/30/2015
=========================================================================================

* Improvements
    - Added two new glyphs: .wj-glyph-plus and .wj-glyph-minus.
    - Improved FlexGrid cell templates for Angular performance.
    - Improved CollectionView grouping and sorting performance.
    - wj-tooltip Angular directive now supports interpolated values.
    - Added disposeAll static method to the Control class to make it easier
      to dispose of controls when their host elements are removed from the DOM.
    - Added add/removeEventListener methods to the Control class to make it easier 
      to remove event listeners when the control is disposed.

* Bug fixes
    - FlexPie's tooltips work correctly with different combinations of selectedItemOffset
      and selectedItemPosition properties (TFS 114962).
    - FlexChart itemFormatter had no effect for candle chart (TFS 115512). 

=========================================================================================
Build Number 5.20151.48          Build Date: 04/10/2015
=========================================================================================

* Improvements
    - Added a Control.disabled property (maps to disabled attribute of the host element)
    - Added class names to facilitate custom styling of column headers: 
        wj-sort-asc (column is sorted in ascending order)
        wj-sort-desc (column is sorted in descending order)
        wj-filter-on (column has an active filter)
        wj-filter-off (column has an inactive filter)
* Bug fixes
    - FlexGrid's Row/Column isContentHtml property was not honored in group row headers (TFS 114902)

=========================================================================================
Build Number 5.20151.47          Build Date: 04/08/2015
=========================================================================================

* Improvements
    - Improved FlexGrid cell templates for Angular performance.
    - Changed FlexGrid mouse handler to sort/select on left button only (TFS 114623)
      (reserving the right button for context menus)
* Bug fixes
    - Allow wj-context-menu directive on element level directives.
    - Fixed FlexGrid hit-testing after window resize (TFS 112961)

=========================================================================================
Build Number 5.20151.45          Build Date: 04/02/2015
=========================================================================================

* Improvements
    - Improved grid filter to support value and condition filtering.
    - Added a Menu.isButton property that turns menus into split-buttons.
    - Input and Gauge directives can bind using ng-model directive now, gaining 
      the features specific to ng-model this way.
    - Added WjFlexGridCellTemplate.cell-overflow attribute that allows to change
      cells' style.overflow property declaratively.
    - Optimized grid scrolling performance (especially visible in IE).
* Bug fixes
    - columnLayout method did not work properly in IE9/10 (TFS 112895).
    - CollectionView notified before updating tracking arrays, should notify after.
    - Fixed issue with popup width (popups were sometimes wider than they should be).
    - Fixed old scrolling issue with IE and very large grids (100,000+ rows)
    - Fixed issue with hierarchical FlexGrid's (with childItemsPath assigned) Angular 
      cell templates for regular cells that didn't apply to group header cells.

=========================================================================================
Build Number 5.20151.42          Build Date: 03/17/2015
=========================================================================================

* Improvements
    - Optimized grid scrolling performance.
    - Added markers to indicate the position of rows and columns being dragged.
    - Improved behavior of drop-down grid cells on mobile devices.
    - Added select-all functionality when the user clicks the top-left fixed cell.
    - Changed row and column resize cursors to 'col-resize' and 'row-resize.'
    - Added a FlexGrid.deferResizing property to defer row and column resizing until the 
      user releases the mouse.
    - Added a Column.sortMemberPath property to sort columns based on an alternate binding.
    - Exposed wijmo.showPopup and hidePopup utility methods for positioning popup elements.
    - Added support for multi-item selection in the ListBox control. Set the checkedMemberPath 
      property to the name of a Boolean property in the itemsSource collection and the 
      ListBox adds checkboxes to each item, and fires the itemChecked event when
      the current item is checked or unchecked.
    - Deprecated and removed the wijmo.isTouchDevice method. The method
      actually tested the browser, not the device, so it was useless.
    - Added a LineMarker class to the wijmo.chart module that provides FlexChart with a 
      continuous data point information with optional directional lines  
      as mouse pointer moves over a chart surface.
    - Added a wijmo.chart.interaction extension module with a RangeSelector class
      that allows the user to choose the range of data to display on the specified FlexChart.
    - Added WjFlexGridCellTemplate directive for Angular that allows to define
      a custom template for any type of a FlexGrid cell (column and row headers,
      editing cell, and so on).
    - Cell templates now support element level directives.
    - Wijmo child directives for Angular (like WjFlexGridColumn or WjFlexChartSeries),
      when used in conjunction with ng-repeat directive, now support full-functional
      synchronization with ng-repeat's source array, including items order.

* Bug fixes
    - Fixed issues related to 'focusout,' which is not supported in FireFox.
    - Fixed FlexGrid.getCellBoundingRect so that it works correctly when dir="RTL."
    - Fixed a problem in chart selection when using itemFormatter.
    - Fixed the Clipboard so that it works on Apple OS (detects the 'Apple' key).
    - HitTestInfo.item returns correct value when chart is bounded to CollectionView.
    - Fixed rendering of merged cells when there are frozen areas (TFS 110627).
    - Fixed handling of IME text in ComboBox when isEditable = false (TFS 108547).

=========================================================================================
Build Number 5.20143.39        Build Date: 02/23/2015
=========================================================================================

* Improvements
    - Added a FlexGrid.sortRowIndex property. This property determines the index of 
      the row in the column headers panel that displays the sort icon and can be clicked
      to sort the column. By default, it is set to null, causing the last row in the 
      panel to be the 'sort row.'
    - Raise editing events when pasting data into the FlexGrid (this allows users to
      prevent overwriting of specific cells when pasting).
    - Improved column filters to work with complex properties (e.g. 'state.name', 'state.pop').
    - Exposed wijmo.Binding class used to work with complex properties.

* Bug fixes
    - Fixed several problems with rendering mixed chart types (TFS 96721, 98617).
    - Made pie chart handle negative data values correctly (TFS 89936).
    - Fixed a problem with the pie chart tooltip for the selected slice (TFS 108871).
    - Fixed a problem with chart tooltips in IE11 (TFS 109876).
    - Fixed InputMask cursor positioning on Safari (TFS 109969, 102148, 96927).
    - Fixed aggregate so that it updates correctly after adding new rows (TFS 109119).
    - Improved date/time detection in the FlexGridFilter editor (TFS 109409).
    - Prevented users from dragging rows below the new row template (TFS 109012).
    - Fixed RTL layout so that it works properly in Safari (TFS 109371).
    - Fixed cell templates so that they are honored in GroupRows (regression).
    - Fixed a problem with dropdown controls on mobile browsers.
    - Fixed Wijmo directives for Angular so that they work with the ng-inspector tool.

=========================================================================================
Build Number 5.20143.37        Build Date: 02/15/2015
=========================================================================================

* Improvements
    - Added wijmo.grid.grouppanel module with the GroupPanel control to provide drag&drop
      grouping functionality to the FlexGrid control.
    - Improved the CollectionView sorting logic to place nulls at the bottom of the list,
      regardless of sort direction (Excel behavior).
    - Allow initialization of ObservableArray in constructor.
    - Improved formatting of values in GroupRow node cells.
* Bug fixes
    - The data labels are not visible for data points outside plot area (TFS 109293).
    - Fixed problem with stacked charts when first series has custom chart type (TFS 107530).
    - Fixed problem with FlexGrid.autoSizeRows in grids with word-wrapping and merged columns.
    - Fixed problem with disappearing dropdown controls on mobile devices in case of zoomed in
      pages.
    - Fixed problem with AutoComplete in the Android 4.4.2 Browser where typed characters 
      can be swapped.

=========================================================================================
Build Number 5.20143.35        Build Date: 02/09/2015
=========================================================================================

* Improvements
    - Improved the grouping logic of paged CollectionViews to avoid splitting groups
      between pages and to include all items in aggregates (as opposed to items in
      the current page which was the previous behavior; TFS 139570).
    - Added a CollectionView.sortConverter property. The property specifies a function
      that can be used to customize the sorting behavior of the CollectionView.
    - Improved FlexGrid sorting to take dataMaps into account. Now the grid sorts based
      on display value (as opposed to raw data values which was the previous behavior).
    - Expanded grid keyboard handling: now ctrl+home and ctrl+end navigate to the
      first and last cells on the grid (as opposed to home/end, which navigate to the
      first and last cells on the current row).
    - Added Gauge.origin property. This property determines the starting point used
      for painting the pointer range. Setting it to null causes the gauge to use
      the min property or zero if the range extends from negative to positive values.
    - Clamp InputNumber value between min/max as the user types the value in.
    - Improved behavior of input controls on touch devices.
* Bug fixes
    - Fixed problem with FlexChart updating after changing collection (TFS 107253).
    - Fixed problem with FlexPie bound to CollectionView with currentPosition=-1 (TFS 106270).
    - Fixed problem with calculating axis limits in stacked chart with series that has
      custom chart-type (TFS 106988).
    - FlexPie labels rendered correctly when offset > 0 (TFS 105891).
    - Fixed problem with FlexChart axis minor ticks and grid lines (TFS 101264, 101401).
    - FlexChart legend and titles rendered with default text color (TFS 98329).
    - Fixed problem with rendering bubble and financial charts bound to CollectionView.
    - Fixed problem with FlexGrid when selectionMode == ListBox and empty item sources.
    - Fixed positioning of grid filter editor on frozen columns (TFS 105593).
    - Fixed problem with merging cells in group rows with aggregates (TFS 98610).
    - Allow clearing cells pressing Delete when column has map and is not required (TFS 107058).
    - Improved positioning of InputDate dropdown calendar (TFS 102162).
    - Fixed regression with dropdowns not showing in iOS Safari.

=========================================================================================
Build Number 5.20143.32      Build Date: 01/22/2015
=========================================================================================

* Bug fixes
    - Fixed problem with rendering axis minor ticks (TFS 102152).

=========================================================================================
Build Number 5.20143.30      Build Date: 01/15/2015
=========================================================================================

* Improvements
    - Added support of chart data labels(new properties FlexChart.dataLabel and
      FlexPie.dataLabel).
    - Added wijmo.grid.filter module with FlexGridFilter extension to provide
      Excel-style filtering in grid columns.
    - Added FlexGrid.getCellBoundingRect and GridPanel.getCellBoundingRect methods
      to retrieve the bounds of a given cell.
    - Added FlexGrid.formatItem event to allow multiple subscribers to customize cells
      (itemFormatter allows only one).
    - Added FlexGrid.AutoSizeMode property to customize auto-sizing behavior, as
      well as new events autoSizingColumn, autoSizedColumn, autoSizingRow, autoSizedRow.
    - Improved DropDown control behavior in clipping containers.
    - Added two new glyphs: .wj-glyph-check and .wj-glyph-filter.
    - Child Angular directives for Wijmo (like wj-flex-grid-column) can now be defined using
      the ng-repeat directive.
* Bug fixes
    - Fixed issue with freezing logic in merged cells.
    - Prevent startEditing from working on invisible rows/columns (TFS 100707).
    - Improved selection/sort behavior (TFS 100326).
    - Allow removing boolean values with delete key (TFS 96566).
    - Prevent dragging Group rows and New rows (TFS 88118).
    - Fixed position of drop-down arrows on RTL systems (TFS 97498).
    - Improved position and behavior of sorting glyph on merged columns (TFS 88149).
    - Improved behavior of selection while typing into AutoComplete (TFS 98114).

=========================================================================================
Build Number 5.20143.27      Build Date: 01/06/2015
=========================================================================================

* Bug fixes
    - Fixed problem in chart series x-binding.

=========================================================================================
Build Number 5.20143.26      Build Date: 12/29/2014
=========================================================================================

* Improvements
    - Added initialization options to wijmo.grid.Column constructor
    - Changed default color in InputColor and ColorPicker to white
    - Added support of logarithmic axes(new Axis logBase property).

* Bug fixes
    - Disabled cell templates in GroupRow cells
    - Improved freezing logic in GroupRow cells (TFS 98800)
    - Improved event logic in drop-down cells.
    - ng-style applied to the wj-flex-grid-column directive may cause changes in another
      column styles.

=========================================================================================
Build Number 5.20143.25      Build Date: 12/10/2014
=========================================================================================

* Improvements
    - Added frozenRows and frozenColumns properties to the FlexGrid.
      Frozen cells are non-scrollable (like header cells) but can be selected and 
      edited (like regular cells).
    - Added Axis properties itemsSource, binding, itemFormatter. 
      The properties provide axis label customization.
    - Added Axis overlappingLabels property that controls appearance
      overlapped labels on axis. By default the overlapped labels are hidden.
    - Added event Axis.rangeChanged. 

=========================================================================================
Build Number 5.20143.24      Build Date: 12/10/2014
=========================================================================================

* Improvements
    - Added InputColor and ColorPicker controls to wijmo.input module.
    - Added toHsb, toHsl, fromHsb, fromHsl methods to Color class.
    - Improved Globalize.formatNumber to honor the 'd' format as per the .NET spec.
      (e.g. Globalize.formatNumber(-1234, 'D6') == '-001234')
    - Added chart axis minor ticks and grid lines
      ('minorTickMarks', 'minorGrid' props in Axis class).
    - Added wijmo.chart.Axis.origin property
      This property allows to specify axis position inside plot area.
    - Added 'initialized' event and 'isInitialized' boolean property to Angular directives
      and Knockout Bindings. The property gets a true value and event is triggered after
      the directive has finished initialization of the control with values defined in
      its attributes and child directives.

* Bug fixes
    - CollectionView did not raise itemChanged when removing the current item
      and preserving the current position.

* Bug fixes
    - Fixed problem with column/bar width when using x-value data(TFS 97589). 

=========================================================================================
Build Number 5.20143.23      Build Date: 11/25/2014
=========================================================================================

* Improvements
    - Removed Wijmo 5 dependency on jQuery.
        Starting with this version, Wijmo 5 has no dependencies on external libraries.
    - Added wijmo.grid.Column.showDropDown property
        This option adds drop-down buttons to cells.
        Clicking the button brings up a list based on the column's dataMap.
        This feature requires the wijmo.input module.

* Bug fixes
    - Improved handling of star-sized columns in auto-sized grids; previously the grid
      could sometimes leave room on the right for a scrollbar that wasn't there.

* Breaking changes
    - Calling the wijmo.grid.DataMap constructor with an itemsSource but no selectedValuePath
      or displayMemberPath parameters used to create integer keys for the values; now the 
      array values are used both as values and as keys; this is more convenient for creating
      lists of strings that can be used with drop-downs and avoids the creation of arbitrary
      (and meaningless) keys.

=========================================================================================
Build Number 5.20143.22      Build Date: 11/11/2014
=========================================================================================

* Improvements
    - added KnockoutJS support (see http://wijmo.com/5/docs/topic/wijmo.knockout.Module.html)
    - added InputMask control (see http://wijmo.com/5/docs/topic/wijmo.input.InputMask.Class.html)
    - added Clipboard class (see http://wijmo.com/5/docs/topic/wijmo.Clipboard.Class.html)
    - added 'invalidateAll' static method to Control class.
    - added 'mask' property to InputDate, InputTime controls
    - added 'mask', 'required', 'inputType' properties to FlexGrid.column class
    - added clipboard support in FlexGrid
      ('autoClipboard' prop, 'pasting', 'pasted', 'copying', 'copied' events)
    - added 'rendering' event in FlexChart
    - added multi-axis support to FlexChart 
      ('axisX', 'axisY' props in Axis class and 'axes' collection in FlexChart class)
    - added 'labelAngle' property to chart Axis class.
    - improved on-line help (show/hide inherited members, collapse/expand properties/events/methods).
    - added wijmo.animate method (mainly to avoid dependency on jQuery)

* Bug fixes
    - Could not drag FlexGrid columns one position to the right...
    - Corrected Japanese localization settings in the wijmo.culture.ja.js file.

=========================================================================================
Build Number 5.20142.15      Build Date: 10/03/2014
=========================================================================================

* Improvements
    - First release

* Bug fixes
    - None

* Breaking changes
    - None

